{$A+,B-,E-,F-,G-,I-,N-,O-,V-,X+ }

{$IFDEF DEBUG } {$R+,S+ } {$ELSE } {$D-,L-,R-,S- } {$ENDIF }

{$M $4000, 0, 131072 }

{$IFOPT R+ } {$DEFINE RON } {$ENDIF }
{$IFOPT S+ } {$DEFINE SON } {$ENDIF }

program PCX2VDT;

Uses Dos,RamDisk2,XSer,VDTDisp;


Procedure IbmVdt( Var s : String; Var d : String );
Var i : Byte;
    c : String[1];
    z : String[5];
Begin
 d := '';
 For i := 1 to Length(s) Do
  If s[i]>#128 Then
   Begin
    c := s[i];
    VDTDisp.IbmVdt(c,z);
    d := d+z;
   End
  Else d := d+s[i];
End;


const Speed1200 = 0;
      Speed4800 = 1;
      Speed9600 = 2;
      SpeedUndef = $FF;

Const

      ParUndef  = $FFFF;
      Par7Bits  = EVENPARITY+DATA7BITS+STOP1BIT;
      Par8Bits  = NOPARITY+DATA8BITS+STOP1BIT;


Const
      Default_nCom  = 0;
      Default_Speed = Speed1200;
      Default_Irq   = 0;
      Default_Adr   = 0;
      Default_LgOut = 8192; { 3072; }

      Default_SpeedReel = SpeedUndef;

      nCom       : Byte    = Default_nCom;
      Speed      : Byte    = Default_Speed;
      Irq        : Byte    = Default_Irq;
      Adr        : Word    = Default_Adr;
      LgOut      : Word    = Default_LgOut;

      SpeedReel  : Byte    = Default_SpeedReel;

      ComPar     : Word    = ParUndef;


Const Roto : Array[0..3] Of Char = ('-','\','|','/');


{$I MINTOOLS.PAS }


Function  GetCPSReel : Word;
Begin
 GetCPSReel := 11520 Div TabSpeed[SpeedReel].BD;
End;



Type PGTableRec = ^GTableRec;

     GTableRec = Record
       nTable : Word;
       Table  : String;
       Next   : PGTableRec;
      End;

     GTArray  = Array[1..255] Of Word;
     PGTArray = ^GTArray;

Const GraphTable : GTableRec = (
        nTable : 1;
        Table  : '"'',-./:;=\_''`{|}~';
        Next   : NIL
       );

      FirstTable : PGTableRec = @GraphTable;


Const LgG1 = 96;

Var JeuG1  : Array[0..LgG1-1] Of MinMatrice;  { Initialis au dbut }
    JeuG1D : Array[0..LgG1-1] Of MinMatrice;

    PixJeuG0  : Array[0..LgG0-1] Of Byte;
    PixJeuG1  : Array[0..LgG1-1] Of Byte;
    PixJeuG1D : Array[0..LgG1-1] Of Byte;
    PixJeuG2  : Array[0..LgG2-1] Of Byte;
    PixJeuG2B : Array[0..LgG2B-1] Of Byte;


    GC        : PGTArray;
    LgGC      : Byte;

    GCP       : PGTArray;
    LgGCP     : Byte;


const { #25#x -> IBM o x<>65,66,67,72,75 }
      TabSS2 : array[1..LgG2] of char =
        ('_','','$','#',#21,#27,#24,#26,#25,'','','','','','',
         '','','');

      TabAccent : array[1..LgG2B] of char = ('','a','','',
                                             '','','','',
                                             'i','i','','',
                                             'o','o','','',
                                             '','u','','','');



Procedure InitJeuG1;
Var Mat : MinMatrice;
    x   : Byte;
    i   : Byte;
    gra : Byte;
Begin
 For gra := 0 To LgG1-1 Do
  Begin
   x := ((gra Shr 1) And 1)*15+(gra And 1)*240;
   For i := 0 To 2 Do Mat[i] := x;

   x := ((gra Shr 3) And 1)*15+((gra Shr 2) And 1)*240;

   For i := 3 To 6 Do Mat[i] := x;

   x := ((gra Shr 5) And 1)*15+((gra Shr 4) And 1)*240;

   For i := 7 To 9 Do Mat[i] := x;

   JeuG1[gra] := Mat;

   Mat[0] := Mat[0] And Not(128+8);
   Mat[1] := Mat[1] And Not(128+8);
   Mat[2] := 0;
   Mat[3] := Mat[3] And Not(128+8);
   Mat[4] := Mat[4] And Not(128+8);
   Mat[5] := Mat[5] And Not(128+8);
   Mat[6] := 0;
   Mat[7] := Mat[7] And Not(128+8);
   Mat[8] := Mat[8] And Not(128+8);
   Mat[9] := 0;

   JeuG1D[gra] := Mat;
  End;
End;


Procedure InitPixJeu( Var p; Var px; LgG : Byte );
Var i : Byte;
    j : Byte;
    k : Byte;
    Jeu : Array[0..255] Of MinMatrice Absolute p;
    Pix : Array[0..255] Of Byte Absolute px;
    Mat : PMinMatrice;
    h : Byte;
    z : Byte;
Begin
 For i := 0 To LgG-1 Do
  Begin
   Mat := @Jeu[i];
   h   := 0;
   For j := 0 To 9 Do
    Begin
     z := Mat^[j];
     For k := 0 To 7 Do
      If ((z Shr k) And 1)<>0 Then Inc(h);
    End;
   Pix[i] := h;
  End;
End;


Procedure InitPixJeux;
Begin
 InitPixJeu(JeuG0,PixJeuG0,LgG0);
 InitPixJeu(JeuG1,PixJeuG1,LgG1);
 InitPixJeu(JeuG1D,PixJeuG1D,LgG1);
 InitPixJeu(JeuG2,PixJeuG2,LgG2);
 InitPixJeu(JeuG2B,PixJeuG2B,LgG2B);
End;


type TpParam = record
         n : string[3];
         m : byte;      { 0=> rien 1=> Flip/Flop +-  2=paramtre }
       end;

const CM_SemiGraph  = 0;
      CM_DRCS       = 1;
      CM_PCX        = 2;
      CM_JPEG       = 3;
      CM_ENV        = 4;

      P_Rien = 0;
      P_Flip = 1;
      P_Egal = 2;

const CFGFileName = 'PCX2VDT';

      NbParam = 69;
      TabParam : array[1..NbParam] of TpParam = (
        ( n:'V';    m:P_Flip ),  { /V+-   Introduction du code #12 }
        ( n:'V0';   m:P_Flip ),  { /V0+-  Vider la ligne 0 }
        ( n:'R';    m:P_Flip ),  { /R+-   Code de passage en mode rouleau }
        ( n:'MM';   m:P_Flip ),  { /MM+-  codes special modem minitel }
        ( n:'P';    m:P_Egal ),  { /P=    Entre des coords pcx }
        ( n:'M';    m:P_Egal ),  { /M=    Entre des coords min }
        ( n:'L';    m:P_Egal ),  { /L=    Traitement de la luminiosit }
        ( n:'C';    m:P_Egal ),  { /C=    Emission simultan sur un port com }
        ( n:'SV';   m:P_Egal ),  { /SV=   sauve }
        ( n:'EX';   m:P_Egal ),  { /EX=   extension videotex par defaut }
        ( n:'OG';   m:P_Flip ),  { /OG+-  pousse l'optimisation }
        ( n:'T';    m:P_Flip ),  { /T+-   test: ne sauvegarde pas }
        ( n:'D';    m:P_Flip ),  { /D+-   Conversion en DRCS }
        ( n:'TT';   m:P_Egal ),  { /TT=   taille texte DRCS }
        ( n:'RD';   m:P_Egal ),  { /RD=   Resolution DRCS }
        ( n:'CT';   m:P_Egal ),  { /CT=   Couleur du trait }
        ( n:'CF';   m:P_Egal ),  { /CF=   Couleur du Fond (G1 seul) }
        ( n:'OD';   m:P_Flip ),  { /OD+-  Optimisation des dessins communs }
        ( n:'MT';   m:P_Egal ),  { /MT=   Mode de Tlchargement }
        ( n:'G0';   m:P_Egal ),  { /G0=   Domaine utilisable du G0 }
        ( n:'G1';   m:P_Egal ),  { /G1=   idem du G1 }
        ( n:'BW';   m:P_Egal ),  { /BW=   mode bw,pivot,propage erreur }
        ( n:'TP';   m:P_Flip ),  { /TP+-  taille proportionn lorsque double }
        ( n:'OP';   m:P_Flip ),  { /OP+-  optimise au plus proche }
        ( n:'OI';   m:P_Flip ),  { /OI+-  recherche l'inverse }
        ( n:'PE';   m:P_Egal ),  { /PE=   taux de proche-erreur }

        ( n:'OR';   m:P_Flip ),  { /OR+-  Optimisation des repetitions }
        ( n:'ORX';  m:P_Flip ),  { /ORX+- Opt.Rep standard }
        ( n:'ORC';  m:P_Flip ),  { /ORC+- Opt.Rep avec le code CAN }
        ( n:'OSG';  m:P_Flip ),  { /OSG+- Opt.Special graphique }
        ( n:'OST';  m:P_Flip ),  { /OST+- Opt.Special texte }
        ( n:'CSI';  m:P_Flip ),  { /CSI+- Opt.avec CSI }
        ( n:'OV';   m:P_Flip ),  { /OV+-  Optimise avec des Vides }
        ( n:'DC';   m:P_Flip ),  { /DC+-  Autorise ou debord.curseur }

        ( n:'ODM';  m:P_Flip ),  { /ODM  Optimisation DRCS Mixte }
        ( n:'GS';   m:P_Flip ),  { /GS   Autorise G1 }
        ( n:'GSD';  m:P_Flip ),  { /GSD  Autorise G1 Disjoint }
        ( n:'OSP';  m:P_Flip ),  { /OSP  Opt.Proche G1 }
        ( n:'CGT';  m:P_Egal ),  { /CGT=  Creer G Table... }
        ( n:'OPD';  m:P_Flip ),  { /OPD  Opt.Proche DRCS }
        ( n:'OPM';  m:P_Flip ),  { /OPM  Opt.Proche Mixte }
        ( n:'OPX';  m:P_Flip ),  { /OPX  Opt.Proche maximal }
        ( n:'PCX';  m:P_Flip ),  { /PCX  Crer un fichier .PCX }
        ( n:'GT';   m:P_Egal ),  { /GT=   ntable ou String }
        ( n:'GTP';  m:P_Egal ),  { /GTP=  idem mais pour les "proche" }
        ( n:'GC';   m:P_Flip ),  { /GC   autorise mixte G0 et G2 }
        ( n:'GCP';  m:P_Flip ),  { /GCP  autorise mixte proche G0 et G2 }
        ( n:'SIL';  m:P_Flip ),  { /SIL  inhibe detection du minitel }
        ( n:'OPV';  m:P_Flip ),  { /OPV  active recherche proche variable }
        ( n:'M0';   m:P_Egal ),  { /M0=   Message d'invite a attendre MT=2 }
        ( n:'VD';   m:P_Flip ),  { /VD   Vide DRCS avant affichage ... }
        ( n:'ENV';  m:P_Flip ),  { /ENV  Envoi une page sur minitel }
        ( n:'OPP';  m:P_Flip ),  { /OPP  Optimisation Proche Pousse }
        ( n:'OPR';  m:P_Flip ),  { /OPR  Optim.Proche pousse Rapide }
        ( n:'RL';   m:P_Egal ),  { /RL=   vitesse reelle d'affichage }
        ( n:'7B';   m:P_Rien ),  { /7B    force en 7 bits }
        ( n:'8B';   m:P_Rien ),  { /8B    force en 8 bits }
        ( n:'XB';   m:P_Rien ),  { /XB    recherche en 7 et 8 bits }
        ( n:'PAR';  m:P_Egal ),  { /PAR=  PBS }
        ( n:'J';    m:P_Flip ),  { /J    conversion JPEG PCX->64->JPEG->VDT }
        ( n:'JJ';   m:P_Flip ),  { /JJ   conversion 64->JPEG->VDT }
        ( n:'JV';   m:P_Flip ),  { /JV   conversion JPEG->VDT }
        ( n:'JQ';   m:P_Egal ),  { /JQ=   qualit de la conversion JPEG }
        ( n:'JEX';  m:P_Egal ),  { /JEX=  logiciel externe pour la conversion }
        ( n:'JPA';  m:P_Egal ),  { /JPA=  paramtres du logiciel externe }
        ( n:'PZ';   m:P_Flip ),  { /PZ   option sur la lecture de PCX }
        ( n:'JM';   m:P_Flip ),  { /JM   postionnement du JPEG? }
        ( n:'JFF';  m:P_Flip ),  { /JFF  filtre JPEG }
        ( n:'JCP';  m:P_Egal )   { /JCP=  texte copyright libre }
        );

      _V    = 1;
      _V0   = 2;
      _R    = 3;
      _MM   = 4;
      _P    = 5;
      _M    = 6;
      _L    = 7;
      _C    = 8;
      _SV   = 9;
      _EX   = 10;
      _OG   = 11;
      _T    = 12;
      _D    = 13;
      _TT   = 14;
      _RD   = 15;
      _CT   = 16;
      _CF   = 17;
      _OD   = 18;
      _MT   = 19;
      _G0   = 20;
      _G1   = 21;
      _BW   = 22;
      _TP   = 23;
      _OP   = 24;
      _OI   = 25;
      _PE   = 26;

      _OR   = 27;
      _ORX  = 28;
      _ORC  = 29;
      _OSG  = 30;
      _OST  = 31;
      _CSI  = 32;
      _OV   = 33;
      _DC   = 34;

      _ODM  = 35;
      _GS   = 36;
      _GSD  = 37;
      _OSP  = 38;

      _CGT  = 39;

      _OPD  = 40;
      _OPM  = 41;
      _OPX  = 42;

      _PCX  = 43;

      _GT   = 44;
      _GTP  = 45;

      _GC   = 46;
      _GCP  = 47;

      _SIL  = 48;

      _OPV  = 49;

      _M0   = 50;

      _VD   = 51;

      _ENV  = 52;

      _OPP  = 53;
      _OPR  = 54;

      _RL   = 55;

      _7B   = 56;
      _8B   = 57;
      _XB   = 58;
      _PAR  = 59;

      _J    = 60;
      _JJ   = 61;
      _JV   = 62;
      _JQ   = 63;
      _JEX  = 64;
      _JPA  = 65;

      _PZ   = 66;
      _JM   = 67;

      _JFF  = 68;
      _JCP  = 69;


      Default_gX   = 0;
      Default_gY   = 0;
      Default_gLg  = 32767;
      Default_gNb  = 32767;

      Default_mX   = 0;
      Default_mY   = 1;
      Default_mLg  = 40;
      Default_mNb  = 24;

      Default_gBLo  = 0;
      Default_gBHi  = 100;
      Default_gLux  = 0;

      T_Normale     = 0;
      T_Haute       = 1;
      T_Large       = 2;
      T_Double      = T_Haute+T_Large;

      Default_Taille = T_Normale;

      Default_RDX   = 8;
      Default_RDY   = 10;

      Default_CT    = 7;
      Default_CF    = 0;

      MT_Fin        = 0;
      MT_Pendant    = 1;
      MT_Debut      = 2;
      MT_Disjoint   = 3;

      Default_MT    = MT_Fin;
      Default_MTParam = 0;

      Default_BWMode = 0;
      Default_BWPiv  = 50;
      Default_BWProp = 70;

      Default_PE     = 5;
      Default_OPV    = FALSE;

      Default_ODM    = TRUE;

      Default_OPD    = TRUE;
      Default_OPM    = TRUE;
      Default_OPX    = TRUE;

      Default_GS     = TRUE;
      Default_GSD    = TRUE;
      Default_OSP    = TRUE;

      Default_GC     = TRUE;
      Default_GCP    = TRUE;

      Default_VD     = FALSE;


Const DefaultCfg : VDispCfg = (
          CSI          : FALSE;   { Optimise deplacement avec CSI }
          OptInvGrp    : TRUE;    { Optimise si invisible }
          GXor         : FALSE;
          OptInvTxt    : TRUE;    { Optimise si invisible }
          OptRepet     : TRUE;    { Optimise si repetition }
          xRep         : FALSE;   { fait toujours prcder le car  repeter }
          ComplAsSpace : FALSE;
          ForceDelGrp  : FALSE;
          ForceDelTxt  : FALSE;
          VideAsSpace  : FALSE;
          OptWithCan   : TRUE;    { optimise avec le code CAN }
          OptSpclGrp   : TRUE;    { optimisation special avec code #14 }
          OptSpclTxt   : TRUE;    { op avec le code #15 }
          C15Clr       : FALSE;
          OptMem       : OM_Nothing;
          DebCursor    : FALSE;   { autorise le debordement du curseur }
          OptNilDRCS   : TRUE;
          NoCR         : FALSE;
          Scroll       : FALSE    { l'cran est en mode rouleau ? }
        );


      VideEcran  : boolean = TRUE;
      VideLZ     : boolean = FALSE;

      Scrolling  : boolean = TRUE;
      MModem     : boolean = FALSE;
      OptGraphik : Boolean = TRUE;
      OptWithVide: Boolean = FALSE;
      Test       : Boolean = FALSE;

      gX         : Word    = Default_gX;
      gY         : Word    = Default_gY;
      gLg        : Integer = Default_gLg;
      gNb        : Integer = Default_gNb;

      mX         : Byte    = Default_mX;
      mY         : Byte    = Default_mY;
      mLg        : Byte    = Default_mLg;
      mNb        : Byte    = Default_mNb;

      gBLo       : Integer = Default_gBLo;
      gBHi       : Integer = Default_gBHi;
      gLux       : Integer = Default_gLux;

      { DRCS only : }

      ConvMode   : Byte    = CM_SemiGraph;
      G0Taille   : Byte    = Default_Taille;
      RDX        : Byte    = Default_RDX;
      RDY        : Byte    = Default_RDY;

      CTrait     : Byte    = Default_CT;
      CFond      : Byte    = Default_CF;

      OptDRCS    : Boolean = TRUE;
      ModeTele   : Byte    = Default_MT;
      ParamTele  : Integer = Default_MTParam;

      BWMode     : Byte    = Default_BWMode;  { mode de conversion }
      BWPiv      : Byte    = Default_BWPiv;   { 0..100% }
      BWProp     : Byte    = Default_BWProp;  { 0..100% }

      TailleProp : Boolean = TRUE;            { par dfaut }

      OptProche  : Boolean = TRUE;

      OptInverse : Boolean = TRUE;

      ProcheErr  : Byte    = Default_PE;
      ProcheVar  : Boolean = Default_OPV;

      GCharMax   = 94;

      OptMixte   : Boolean = Default_ODM;

      OptProcheDRCS  : Boolean = Default_OPD;

      OptProcheMixte : Boolean = Default_OPM;

      OptProcheMax   : Boolean = Default_OPX;

      CanUseG1    : Boolean = Default_GS;
      CanUseG1D   : Boolean = Default_GSD;
      CanOptG1    : Boolean = Default_OSP;

      GCTable     : PGTableRec = NIL;
      GCPTable    : PGTableRec = @GraphTable;

      CanUseG0G2  : Boolean = Default_GC;
      CanOptG0G2  : Boolean = Default_GCP;

      Silence     : Boolean = FALSE;

      VideDRCS    : Boolean = Default_VD;

      OptProchePoussee : Boolean = FALSE;
      OptProcheRapide  : Boolean = FALSE;

      { JPEG/PHOTO only }

      Default_JPEGQua = 18;
      Default_JPEGExec = 'ALCHEMY.EXE';
      Default_JPEGExecParam = '-j~Q -b -q -o ~S ~D >NULL';
      Default_JPEGSitu = TRUE;

      Default_JPEGFiltre = TRUE;
      Default_JPEGCP     = '';

      JPEGMODE_NORM   = 0;
      JPEGMODE_JPEG   = 1;
      JPEGMODE_VDT    = 2;

      JPEGMode    : Byte = JPEGMODE_NORM;
      JPEGQua     : Integer = Default_JPEGQua;
      JPEGSitu    : Boolean = Default_JPEGSitu;
      JPEGFiltre  : Boolean = Default_JPEGFiltre;
      JPEGCP      : String = Default_JPEGCP;

      Default_PCXZero = FALSE;

      PCXZero     : Boolean = Default_PCXZero;

Type
     PixArray = Array[0..GCharMax-1] Of Byte;
     PPixArray = ^PixArray;

     GRec = Record
       First  : Byte;
       Nb     : Byte;
       TabPix : PixArray;
       Read   : Byte;
       iRead  : Byte;
      End;


     POptRec = ^OptRec;
     OptRec = Record
       Next   : POptRec;
       nOpt   : Word;
       Save   : Boolean;
       Opt    : String;
      End;

Const
      CFG_NIL    = 0;
      CFG_SAVE   = 1;
      CFG_LIST   = 2;

var PCXName     : PathStr;
    VDTName     : PathStr;
    DefaultPath : PathStr;
    DefaultExt  : ExtStr;

    TabG        : Array[0..1] Of GRec;

    RamDRCS     : PVDispRamDRCS;

    VD          : VDispRec;

    FRam        : RamFile;   { RAM }

    ModeScroll  : Boolean;

    FirstOpt    : POptRec;
    WorkOptions : Byte;
    NeedHelp    : Boolean;
    M0Str       : String;
    JPEGExec    : String;
    JPEGExecParam : String;

Function ValStr( x : Longint; lg : Word ) : String;
Var s : String;
Begin
 Str(x:lg,s);
 ValStr := s;
End;

procedure FinalName;
var r : DirStr;
    pn: NameStr;
    n : NameStr;
    e : ExtStr;
    i : word;
begin
  FSplit(PCXName,r,pn,e);

  If pn='' Then PCXName := ''
  Else
   Begin
    if e='' then e := '.PCX';
    PCXName := r+pn+e;
   End;

  if VDTName='' then VDTName := DefaultPath+pn
  else
   begin
    FSplit(VDTName,r,n,e);
    If n='' Then n := pn;
    if e<>'' then DefaultExt := e;
    If r='' Then r := DefaultPath;
    VDTName := r+n;
   end;

  for i := 1 to length(DefaultExt) Do DefaultExt[i] := UpCase(DefaultExt[i]);
  for i := 1 to length(VDTName) do VDTName[i] := UpCase(VDTName[i]);
  for i := 1 to length(PCXName) do PCXName[i] := UpCase(PCXName[i]);
end;


Function GetMainName : String;
Var Lig : String;
var r : DirStr;
    n : NameStr;
    e : ExtStr;
Begin
 Lig := ParamStr(0);
 If Lig='' Then Lig := CFGFileName;
 FSplit(Lig,r,n,e);
 If n='' Then n := CFGFileName;
 GetMainName := n;
End;


function FileParam( var f : text; nom : string; DosPath : boolean ) : String;
var r : DirStr;
    n : string[12];
    e : ExtStr;
begin
  FSplit(nom,r,n,e);
  n := n+'.CFG';

  { recherche d'abord dans le rpertoire courant }
  Assign(f,n);

  reset(f);
  if IoResult=0 then
   Begin
    FileParam := n;
    exit;
   End;

  { recherche dans le rpertoire o est la source }
  if r<>'' then
    begin
      Assign(f,r+n);
      reset(f);
      if IoResult=0 then
       Begin
        FileParam := r+n;
        exit;
       End;
    end;

  if DosPath then
    begin { recherche dans le PATH dos }
      nom := FSearch(n,GetEnv('PATH'));
      if nom<>'' then
        begin
          Assign(f,nom);
          reset(f);
          if IoResult=0 then
           Begin
            FileParam := nom;
            exit;
           End;
        end;
    end;

  FileParam := '';
end;


Function StrStr( Var s : String; nPar : Word; LargeParam : Boolean ) : String;
Var i  : Word;
    n  : String;
    lc : Char;
    Sep : Char;
    OrSep : Char;
Begin
 i := 1;
 If LargeParam Then
  Begin
   Sep   := ' ';
   OrSep := #0;
  End
 Else
  Begin
   Sep   := ',';
   OrSep := ':';
  End;

 While nPar>1 do
  Begin
    If LargeParam Then While (i<=length(s)) And (s[i]=' ') Do Inc(i);
    While (i<=length(s)) And (s[i]<>Sep) And (s[i]<>OrSep) Do
     Begin
      If s[i]='''' Then
       Begin
        lc := #0;
        Inc(i);
        While (i<=Length(s)) And Not((lc='''') And (s[i]<>'''')) Do
         Begin
          If lc='''' Then lc := #0 Else lc := s[i];
          Inc(i);
         End;
       End
      Else Inc(i);
     End;
    If i>length(s) Then
     Begin
      StrStr := '';
      Exit;
     End;
    Dec(nPar);
    Inc(i);
  End;
 n := '';
 While (i<=length(s)) And (s[i]<>Sep) And (s[i]<>OrSep) Do
  Begin
   If s[i]='''' Then
    Begin
     lc := '''';
     Repeat
      If lc='''' Then lc := #0 Else lc := s[i];
      Inc(n[0]);
      n[Length(n)] := s[i];
      Inc(i);
     Until Not((i<=Length(s)) And Not((lc='''') And (s[i]<>'''')));
    End
   Else
    Begin
     Inc(n[0]);
     n[Length(n)] := s[i];
     Inc(i);
    End;
  End;
 StrStr := n;
End;


Function ValBin( Var S : String; Var x : Longint ) : Boolean; Assembler;
Asm
    cld
    push ds
    lds  si, [S]
    lodsb               { lire la longueur de la chaine }
    xor  ah, ah         { longueur de la chaine dans AX }

    mov  cx, ax
    jcxz @FALSE         { saute si chaine vide }
    xor  bx, bx
    xor  dx, dx         { dx:bx = entier long en cours d'etude }
@BOUCLE:
    lodsb               { lit le car }
    sub  al, '0'        { -'0' }
    cmp  al, 1
    ja   @FALSE         { erreur de syntaxe! '0' ou '1' seulement ! }
    cmc                 { car, si al=1 => cf=0, si al<1 => cf=1 !! }
    rcl  bx, 1          { rotate with carry }
    rcl  dx, 1
    jc   @FALSE         { depassement de capacit 16 bits ! }
    loop @BOUCLE

    lds  si, [x]
    mov  [si], bx
    mov  [si+2], dx     { ecrit le resultat }
    mov  al, TRUE       { sort avec TRUE }
    JMP  @FIN
@FALSE:
    XOR  AL, AL
@FIN:
    pop  ds
End;


Function ValHex( Var S : String; Var x : Longint ) : Boolean; Assembler;
Asm
        cld
        push ds
        lds  si, [S]
        lodsb
        xor  ah, ah         { longueur de la chaine dans AX }
        mov  cx, ax
        jcxz @FALSE         { saute si vide }
        xor  bx, bx
        xor  dx, dx         { dx:bx = entier long en cours d'etude }
@BOUCLE:
        lodsb               { lit le car }
        cmp  al, 'a'
        jb   @03
        cmp  al, 'f'
        ja   @FALSE         { car incorrecte }
        sub  al, 32         { -32!  UpCase(al) }
        jmp  @05
@03:
        cmp  al, '0'
        jb   @FALSE
        cmp  al, '9'
        ja   @04
        {
          0..9
        }
        sub  al, '0'
        jmp  @CONT
@04:
        cmp  al, 'A'
        jb   @FALSE
        cmp  al, 'F'
        ja   @FALSE
        {
          A..F
        }
@05:
        sub  al, 'A'-10
@CONT:
        test dx, 0F000h
        jnz  @FALSE         { depassement de capacit }
        push cx             { sauve cx }
        mov  cl, 4
        shl  dx, cl         { dx*16  dx= xxxx xxxx xxxx 0000 }
        mov  ah, bh         {        ah= ???? xxxx           }
        shr  ah, cl         {        ah= 0000 ????           }
        or   dl, ah         {        dx= xxxx xxxx xxxx ???? }
        shl  bx, cl
        or   bl, al
        pop  cx             { restore cx }
        loop @BOUCLE

        lds  si, [x]
        mov  [si], bx
        mov  [si+2], dx     { ecrit le resultat }
        mov  al, TRUE       { sort avec TRUE }
        JMP  @FIN
@FALSE:
        xor  al, al
@FIN:
        pop  ds
End;


{ traduction en fonction du type de nombre }

Function ValX( Var S : String; Var x : Longint ) : Boolean;
Var SN  : String[32];
    Err : Word;
Begin
  If (S<>'') And (Length(S)<SizeOf(SN)) Then
    Case UpCase(S[1]) Of
      '%','B' : Begin
                  SN[0] := Char(Length(S)-1);
                  Move(S[2],SN[1],Length(SN));
                  ValX := ValBin(SN,x);
                End;
      '$','H' : Begin
                  SN[0] := Char(Length(S)-1);
                  Move(S[2],SN[1],Length(SN));
                  ValX := ValHex(SN,x);
                End;
      '#','D' : Begin
                  SN[0] := Char(Length(S)-1);
                  Move(S[2],SN[1],Length(SN));
                  Val(SN,x,Err);
                  ValX := Err=0;
                End;
    Else
      Case UpCase(S[Length(S)]) Of
        'B' : Begin
                SN[0] := Char(Length(S)-1);
                Move(S[1],SN[1],Length(SN));
                ValX := ValBin(SN,x);
              End;
        'H' : Begin
                SN[0] := Char(Length(S)-1);
                Move(S[1],SN[1],Length(SN));
                ValX := ValHex(SN,x);
              End;
        'D' : Begin
                SN[0] := Char(Length(S)-1);
                Move(S[1],SN[1],Length(SN));
                Val(SN,x,Err);
                ValX := Err=0;
              End;
      Else
        Begin
          Val(S,x,Err);
          ValX := Err=0;
        End;
      End
    End
  Else ValX := FALSE;
End;



function StrValLong( var s : string; nPar : word;
                     var result : Longint; default : Longint ) : boolean;
var n : string[20];
    x : longint;
begin
  n := StrStr(s,nPar,FALSE);
  if n='' then
    begin
      result := default;
      StrValLong := TRUE;
    end
  else
    begin
      If ValX(n,x) Then
        begin
          result := x;
          StrValLong := TRUE;
        end
      else StrValLong := FALSE;
    end;
end;


function StrValByte( var s : string; nPar : word;
                     var result : Byte; default : Byte ) : boolean;
Var r : Longint;
Begin
 If StrValLong(s,nPar,r,default) And (r>=0) And (r<=255) Then
  Begin
   result := Byte(r);
   StrValByte := TRUE;
  End
 Else StrValByte := FALSE;
End;


Function StrValWord( var s : string; nPar : word;
                     var result : Word; default : Word ) : boolean;
Var r : Longint;
Begin
 If StrValLong(s,nPar,r,default) And (r>=0) And (r<=65535) Then
  Begin
   result := Word(r);
   StrValWord := TRUE;
  End
 Else StrValWord := FALSE;
End;


function StrValInt( var s : string; nPar : word;
                    var result : Integer; default : Integer ) : boolean;
Var r : Longint;
Begin
 If StrValLong(s,nPar,r,default) And (r>=-32768) And (r<=32767) Then
  Begin
   result := Integer(r);
   StrValInt := TRUE;
  End
 Else StrValInt := FALSE;
End;



Function TradStr( s : String; Var Result : String; Max : Word ) : Boolean;
Var Lg : Word;
    r  : Word;
    c  : Char;
    Tm : String[32];
    x  : Longint;
Begin
 Lg := 0;
 r := 1;
 While r<=Length(S) Do
  Begin
   If S[r]='''' Then
    Begin
     c := #0;
     Inc(r);
     While (r<=Length(S)) And Not((c='''') And (S[r]<>'''')) do
      Begin
       If c='''' Then
        Begin
         c := #0;
         Inc(Lg);
         S[Lg] := '''';
        End
       Else
        Begin
         c := S[r];
         If c<>'''' Then
          Begin
           Inc(Lg);
           S[Lg] := c;
          End;
        End;
       Inc(r);
      End;
     If c<>'''' Then
      Begin
       TradStr := FALSE;
       Exit;
      End;
    End
   Else
    If S[r]='#' Then
     Begin
      Tm := '';
      Inc(r);
      While (Length(Tm)<SizeOf(Tm)-1) And
            (r<=Length(S)) And (S[r]<>'''') And (S[r]<>'#') Do
       Begin
         Inc(Tm[0]);
         Tm[Length(Tm)] := S[r];
         Inc(r);
       End;
      If ((r>Length(S)) Or (S[r]='''') Or (S[r]='#')) And
         ValX(Tm,x) And (x>=0) And (x<=255) Then
       Begin
        Inc(Lg);
        S[Lg] := Char(x);
       End
      Else
       Begin
        TradStr := FALSE;
        Exit;
       End;
     End
    Else
     Begin
      TradStr := FALSE;
      Exit;
     End;
  End;
 S[0] := Char(Lg);
 If Max<Length(s) Then s[0] := Char(Max);
 Result := S;
 TradStr := TRUE;
End;


Function  FixeTable( nt : Word; Var Table : PGTableRec ) : Boolean;
Var t : PGTableRec;
Begin
 If nt=0 Then
  Begin
   Table := NIL;
   FixeTable := TRUE;
   Exit;
  End;
 t := FirstTable;
 While t<>NIL Do
  Begin
   If t^.nTable=nt Then
    Begin
     Table := t;
     FixeTable := TRUE;
     Exit;
    End;
   t := t^.Next;
  End;
 FixeTable := FALSE;
End;


Function  FixeTableStr( s : String; Var Table : PGTableRec ) : Boolean;
Var t : PGTableRec;
Begin
 If s='' Then
  Begin
   Table := NIL;
   FixeTableStr := TRUE;
   Exit;
  End;

 If TradStr(s,s,SizeOf(s)-1) Then
  Begin
   New(t);
   t^.nTable := 0;
   t^.Table  := s;
   t^.Next   := NIL;
   Table := t;
   FixeTableStr := TRUE;
  End
 Else FixeTableStr := FALSE;
End;


function StrSpeed( var s : string; nPar : word;
                   var result : Byte; default : Byte ) : boolean;
Var r  : Longint;
    z  : Byte;
    ok : Boolean;
Begin
 If StrValLong(s,nPar,r,-1) And (r>=0) And (r<=65535) Then
  Begin
   ok := TRUE;
   Case Word(r) Of
    1, 12, 120, 1200 : z := Speed1200;
    4, 48, 480, 4800 : z := Speed4800;
    9, 96, 960, 9600 : z := Speed9600;
   Else ok := FALSE;
   End;
   If ok Then
    Begin
     result := z;
     StrSpeed := TRUE;
    End
   Else StrSpeed := FALSE;
  End
 Else
  If r=-1 Then
   Begin
    result := default;
    StrSpeed := TRUE;
   End
  Else StrSpeed := FALSE;
End;


Function  TradComParam( s : String; Var Param : Word ) : Boolean;
Var a : Word;
Begin
 TradComParam := FALSE;
 If Length(s)=3 Then
  Begin
   Case UpCase(s[1]) Of
    'E' : a := EVENPARITY;
    'O' : a := ODDPARITY;
    'N' : a := NOPARITY;
   Else Exit;
   End;

   Case s[2] Of
    '5' : Inc(a,DATA5BITS);
    '6' : Inc(a,DATA6BITS);
    '7' : Inc(a,DATA7BITS);
    '8' : Inc(a,DATA8BITS);
   Else Exit;
   End;

   Case s[3] Of
    '1' : Inc(a,STOP1BIT);
    '2' : Inc(a,STOP2BITS);
   Else Exit;
   End;

   Param := a;
   TradComParam := TRUE;
  End;
End;



function ChargeParam : boolean;
var f    : text;
    Disk : boolean;
    nPar : word;
    xPar : word;
    nLig : word;
    EndB : boolean;
    Lig  : string;
    SrcOpt : String;
    PcxPar : word;
    VdtPar : Word;
    CfgPar : Word;
    LstPar : Word;
    CZPar  : Word;

  procedure go( KeepAllOpt, DetectPCX : Boolean );
  var n  : word;
      CurrentOpt : String;

    procedure Erreur( txt : string );
    begin
      Write(txt,' =>   ',CurrentOpt,'   ... ');
      If SrcOpt<>'' Then Write('dans ''',SrcOpt,'''')
      Else Write('sur la ligne de commandes');
      Writeln;
      (*
      if Disk then writeln(txt,'   n',nLig,'  param.n',n)
      else writeln(txt,'   param.n',xPar);
      *)
      EndB := TRUE;
    end;

    Procedure ErreurSyntaxe;
    Begin
     Erreur('Syntaxe incorrecte');
    End;

    Procedure AddCurrentOpt( Var s : String; nOpt : Word );
    Var op : POptRec;
        p  : POptRec;
        n  : POptRec;
        Find : Boolean;
    Begin
     If WorkOptions<>CFG_NIL Then
      Begin
       op := FirstOpt;
       p  := NIL;      { precedent }
       Find := FALSE;
       While op<>NIL Do
        Begin
         If (op^.nOpt=nOpt)  Then
          Begin { supprimer les redondances! (sauf exception) }
           If (nOpt<>_CGT) Then
            Begin
             n := op^.Next;
             If p=NIL Then FirstOpt := n
             Else p^.Next := n;
             FreeMem(op,SizeOf(op^)-SizeOf(op^.Opt)+Length(op^.Opt)+1);
             op := n;
            End
           Else { ignore, mais signale si trouv ... }
            Begin
             p  := op;
             op := op^.Next;
            End;
           Find := TRUE;
          End
         Else
          Begin
           p  := op;
           op := op^.Next;
          End;
        End;

       GetMem(op,SizeOf(op^)-SizeOf(op^.Opt)+Length(CurrentOpt)+1);
       op^.Next := NIL;
       op^.nOpt := nOpt;
       op^.Save := KeepAllOpt Or Find Or Not(nOpt In [_SV,_C,_EX,_T,_SIL,_CGT,_ENV]);
       op^.Opt  := s;
       If p=NIL Then FirstOpt := op
       Else p^.Next := op;
      End;
    End;

    procedure DoIt( p : TpParam; Plus : boolean; var sp : string );
    var i : word;
        Good : Boolean;
        gt   : PGTableRec;
        nt   : Word;
    begin
    {  writeln(nLig:4,' ',n:4,' "',p.n,'" ',p.m,' ',Plus,' "',sp,'"'); }
      for i := 1 to length(p.n) do p.n[i] := UpCase(p.n[i]);
      for i := 1 to NbParam do
        if TabParam[i].n=p.n then
          begin
            if (TabParam[i].m<>p.m) And
               Not((p.m=P_Rien) And (TabParam[i].m=P_Flip)) Then
              begin
                Erreur('Option mal utilise');
                exit;
              end;

            { Mmoriser les options... }
            AddCurrentOpt(CurrentOpt,i);

            Good := TRUE;
            case i of
              _SV   :
                 begin
                   DefaultPath := sp;
                   if (DefaultPath<>'') and
                      (DefaultPath[length(DefaultPath)]<>'\') then
                     begin
                       inc(DefaultPath[0]);
                       DefaultPath[length(DefaultPath)] := '\';
                     end;
                 end;
              _EX   :
                 begin
                   DefaultExt := sp;
                   If DefaultExt='' Then DefaultExt := '.VDT'
                   Else
                    if (DefaultExt<>'') and
                       (DefaultExt[1]<>'.') then
                     begin
                       DefaultExt := '.'+DefaultExt;
                     end;
                 end;
              _V    : VideEcran := Plus;
              _V0   : VideLZ    := Plus;
              _R    : Scrolling := Plus;
              _MM   : MModem    := Plus;
              _P    : Good := StrValWord(sp,1,gX,Default_gX) and
                              StrValWord(sp,2,gY,Default_gY) and
                              StrValInt(sp,3,gLg,Default_gLg) and
                              StrValInt(sp,4,gNb,Default_gNb);
              _M    : Good := StrValByte(sp,1,mX,Default_mX) and
                              StrValByte(sp,2,mY,Default_mY) and
                              StrValByte(sp,3,mLg,Default_mLg) and
                              StrValByte(sp,4,mNb,Default_mNb);
              _L    : Good := StrValInt(sp,1,gBLo,Default_gBLo) and
                              StrValInt(sp,2,gBHi,Default_gBHi) and
                              StrValInt(sp,3,gLux,Default_gLux);
              _C    : Good := StrValByte(sp,1,nCom,Default_nCom) And
                              StrSpeed(sp,2,Speed,Default_Speed) And
                              StrValByte(sp,3,Irq,Default_Irq) and
                              StrValWord(sp,4,Adr,Default_Adr) and
                              StrValWord(sp,5,LgOut,Default_LgOut);
              _OG   : OptGraphik := Plus;
              _T    : Test := Plus;
              _D    : If Plus Then ConvMode := CM_DRCS
                      Else ConvMode := CM_SemiGraph;
              _TT   : Good := StrValByte(sp,1,G0Taille,Default_Taille);
              _RD   : Good := StrValByte(sp,1,RDX,Default_RDX) And
                              StrValByte(sp,2,RDY,Default_RDY);
              _CT   : Good := StrValByte(sp,1,CTrait,Default_CT);
              _CF   : Good := StrValByte(sp,1,CFond,Default_CF);
              _OD   : OptDRCS := Plus;
              _MT   : Begin
                       Good := StrValByte(sp,1,ModeTele,Default_MT) And
                               StrValInt(sp,2,ParamTele,Default_MTParam);
                      End;
              _G0   : Good := StrValByte(sp,1,TabG[0].First,0) And
                              StrValByte(sp,2,TabG[0].Nb,GCharMax);
              _G1   : Good := StrValByte(sp,1,TabG[1].First,0) And
                              StrValByte(sp,2,TabG[1].Nb,GCharMax);
              _BW   : Good := StrValByte(sp,1,BWMode,Default_BWMode) And
                              StrValByte(sp,2,BWPiv,Default_BWPiv) And
                              StrValByte(sp,3,BWProp,Default_BWProp);
              _TP   : TailleProp := Plus;
              _OP   : OptProche := Plus;
              _OI   : OptInverse := Plus;
              _PE   : Good := StrValByte(sp,1,ProcheErr,Default_PE);

              _OR   : DefaultCfg.OptRepet   := Plus;
              _ORX  : DefaultCfg.xRep       := Plus;
              _ORC  : DefaultCfg.OptWithCan := Plus;
              _OSG  : DefaultCfg.OptSpclGrp := Plus;
              _OST  : DefaultCfg.OptSpclTxt := Plus;
              _CSI  : DefaultCfg.CSI        := Plus;

              _OV   : OptWithVide := Plus;

              _DC   : DefaultCfg.DebCursor  := Plus;

              _ODM  : OptMixte := Plus;

              _GS   : CanUseG1 := Plus;
              _GSD  : CanUseG1D := Plus;
              _OSP  : CanOptG1 := Plus;

              _CGT  : Begin
                       If StrValWord(sp,1,nt,0) And (nt<>0) Then
                        Begin
                         New(gt);
                         gt^.nTable := nt;
                         gt^.Table := StrStr(sp,2,FALSE);
                         If (gt^.Table<>'') And
                            TradStr(gt^.Table,gt^.Table,SizeOf(gt^.Table)-1) Then
                          Begin
                           gt^.Next := FirstTable;
                           FirstTable := gt;
                          End
                         Else Good := FALSE;
                        End
                       Else Good := FALSE;
                      End;
              _OPD  : OptProcheDRCS  := Plus;
              _OPM  : OptProcheMixte := Plus;
              _OPX  : OptProcheMax   := Plus;
              _PCX  : If Plus Then ConvMode := CM_PCX
                      Else ConvMode := CM_SemiGraph;
              _GT   : Begin
                       If StrValWord(sp,1,nt,0) Then
                        Begin
                         Good := FixeTable(nt,GCTable);
                        End
                       Else
                        Begin
                         sp := StrStr(sp,1,FALSE);
                         Good := FixeTableStr(sp,GCTable);
                        End;
                      End;
              _GTP  : Begin
                       If StrValWord(sp,1,nt,0) Then
                        Begin
                         Good := FixeTable(nt,GCPTable);
                        End
                       Else
                        Begin
                         sp := StrStr(sp,1,FALSE);
                         Good := FixeTableStr(sp,GCPTable);
                        End;
                      End;
              _GC   : CanUseG0G2 := Plus;
              _GCP  : CanOptG0G2 := Plus;
              _SIL  : Silence := Plus;
              _OPV  : ProcheVar := Plus;
              _M0   : Begin
                       sp := StrStr(sp,1,FALSE);
                       If sp='' Then M0Str := ''
                       Else Good := TradStr(sp,M0Str,SizeOf(M0Str)-1);
                      End;
              _VD   : VideDRCS := Plus;
              _ENV  : If Plus Then ConvMode := CM_ENV
                      Else ConvMode := CM_SemiGraph;
              _OPP  : OptProchePoussee := Plus;
              _OPR  : OptProcheRapide := Plus;
              _RL   : Good := StrSpeed(sp,1,SpeedReel,Default_SpeedReel);

              _7B   : ComPar := Par7Bits;
              _8B   : ComPar := Par8Bits;
              _XB   : ComPar := ParUndef;
              _PAR  : Begin
                       If sp='' Then ComPar := ParUndef
                       Else Good := TradComParam(sp,ComPar);
                      End;
              _J    : If Plus Then
                       Begin
                        ConvMode := CM_JPEG;
                        JPEGMode := JPEGMODE_NORM;
                       End
                      Else ConvMode := CM_SemiGraph;
              _JJ   : If Plus Then
                       Begin
                        ConvMode := CM_JPEG;
                        JPEGMode := JPEGMODE_JPEG;
                       End
                      Else ConvMode := CM_SemiGraph;
              _JV   : If Plus Then
                       Begin
                        ConvMode := CM_JPEG;
                        JPEGMode := JPEGMODE_VDT;
                       End
                      Else ConvMode := CM_SemiGraph;
              _JQ   : Good := StrValInt(sp,1,JPEGQua,Default_JPEGQua);
              _JEX  : Begin
                       sp := StrStr(sp,1,FALSE);
                       If sp='' Then JPEGExec := Default_JPEGExec
                       Else JPEGExec := sp;
                      End;
              _JPA  : Begin
                       sp := StrStr(sp,1,FALSE);
                       If sp='' Then JPEGExecParam := Default_JPEGExecParam
                       Else Good := TradStr(sp,JPEGExecParam,SizeOf(JPEGExecParam)-1);
                      End;
              _PZ   : PCXZero := Plus;
              _JM   : JPEGSitu := Plus;
              _JFF  : JPEGFiltre := Plus;
              _JCP  : Begin
                       sp := StrStr(sp,1,FALSE);
                       If sp='' Then JPEGCP := Default_JPEGCP
                       Else Good := TradStr(sp,JPEGCP,SizeOf(JPEGCP)-1);
                      End;
            else Good := FALSE;
            end;
            If Not(Good) Then ErreurSyntaxe;
            Exit;
          end;
      Erreur('Option inconnue');
    end;

  var is   : word;
      v    : string;
      p    : TpParam;
      x    : word;
      e    : ExtStr;
  begin
    inc(nLig);
    is := 0;
    n  := 0;

    Repeat
     Inc(n);
     v := StrStr(Lig,n,TRUE);

     CurrentOpt := v;

     if v<>'' then
      begin
       inc(xPar);
       If (nPar=0) Or
          ((nPar<>PCXPar) And (nPar<>VDTPar) And
           (nPar<>CfgPar) And (nPar<>LstPar) And
           (nPar<>CZPar)) Then
        Begin
         if v[1]='/' then
          begin
           if v[length(v)]='+' then
             begin
               p.n  := copy(v,2,length(v)-2);
               p.m  := P_Flip;
               v    := '';
               DoIt(p,TRUE,v);
             end
           else
             if v[length(v)]='-' then
               begin
                 p.n  := copy(v,2,length(v)-2);
                 p.m  := P_Flip;
                 v    := '';
                 DoIt(p,FALSE,v);
               end
             else
               begin
                 x := Pos('=',v);
                 If x=0 Then x := Pos(':',v);
                 if x=0 then
                   begin
                     p.n := copy(v,2,length(v)-1);
                     p.m := P_Rien;
                     v   := '';
                     DoIt(p,TRUE,v);
                   end
                 else
                   begin
                     p.n := copy(v,2,x-2);
                     p.m := P_Egal;
                     v   := copy(v,x+1,255);
                     DoIt(p,FALSE,v);
                   end;
               end;
          end
         else
          Begin
           If DetectPCX Then
            Begin
             If VdtPar=0 Then
              Begin
               PCXName := v;
              End;
            End
           Else ErreurSyntaxe;
          End;
        End;
      end;
    Until EndB Or (CurrentOpt='');
  end;

var n : word;
    i : Byte;
begin
  ChargeParam := FALSE;

  FirstOpt    := NIL;    { utile seulement si /CFG ou /LST }
  WorkOptions := CFG_NIL;
  NeedHelp    := FALSE;

  { Examen rapide des donnes en ligne }

  PcxPar := 0;
  VdtPar := 0;
  CfgPar := 0;
  LstPar := 0;
  CZPar  := 0;
  n := 0;
  While (n<ParamCount) Do
   Begin
    inc(n);
    Lig := ParamStr(n);
    if (Lig<>'') Then
     If (Lig[1]<>'/') then
      begin { nom du PCX trouv ? peut etre ... }
       If PcxPar=0 Then
        Begin
         PcxPar := n;  { note }
         PCXName := Lig;
        End
       Else
        Begin
         VdtPar := n;
         VDTName := Lig;
        End;
      end
     Else
      Begin
       For i := 1 To Length(Lig) Do Lig[i] := UpCase(Lig[i]);
       If (Lig='/CFG') And (CfgPar=0) Then
        Begin { Creer un ".CFG" }
         CfgPar := n;
         WorkOptions := CFG_SAVE;
        End
       Else
        If (Lig='/LST') And (LstPar=0) Then
         Begin
          LstPar := n;
          WorkOptions := CFG_LIST;
         End
        Else
         If (Lig='/CZ') And (CZPar=0) Then
          Begin
           CZPar := n;
          End
         Else If Lig='/?' Then NeedHelp := TRUE;
      End;
   End;

  If NeedHelp Then
   Begin
    ChargeParam := FALSE;
    Exit;
   End;


  nPar := 0;

  EndB := FALSE;

  If CZPar=0 Then
   Begin
    Lig := ParamStr(0);
    if Lig='' then Lig := CFGFileName;

    SrcOpt := FileParam(f,Lig,TRUE);
    If SrcOpt<>'' Then
     Begin
      Disk := TRUE;
      nLig := 0;
      xPar := 0;
      while not(EndB) and not(Eof(f)) do
       begin
        Readln(f,Lig);
        go(FALSE,FALSE);
       end;
      Close(f);
     End;

    FinalName;   { premiere fixation }

    If Not(EndB) And (VDTName<>'') Then
     Begin
      SrcOpt := FileParam(f,VDTName,FALSE);
      If SrcOpt<>'' Then
       Begin
         Disk := TRUE;
         nLig := 0;
         xPar := 0;
         while not(EndB) and not(Eof(f)) do
           begin
             Readln(f,Lig);
             go(TRUE,TRUE);
           end;
         Close(f);
       End;
     End;
   End;


  Disk := FALSE;
  nLig := 0;
  xPar := 0;
  SrcOpt := '';
  while not(EndB) and  (nPar<ParamCount) do
    begin
      inc(nPar);
      Lig := ParamStr(nPar);
      go(TRUE,FALSE);
    end;

  FinalName;   { Une deuxime fois... car PCXName peut changer...}

  ChargeParam := not(EndB);
end;



procedure ClrLine;
var i : word;
begin
  write(#13);
  for i := 1 to 79 do write(' ');
  write(#13);
end;


{*********************************
 *                               *
 *           P  C  X             *
 *                               *
 *********************************}

Const LgBufMax = 8192;

      NbPlansMax = 8;

      PPLMax     = 10240;  { pixel par ligne max }

Type
     LongRec = Record
       Lo, Hi : Word;
      End;

     RGB = Record
       Red, Green, Blue : Byte;
      End;

     Pal16 = Array[1..16] Of RGB;

     PCXHeadRec = Record
       Marque   : Byte;
       Version  : Byte;
       Codage   : Byte;
       BPX      : Byte;
       XG       : Word;
       YH       : Word;
       XD       : Word;
       YB       : Word;
       HRes     : Word;
       VRes     : Word;
       Palette  : Pal16;
       Reserve1 : Byte;
       NbPlans  : Byte;
       BPL      : Word;
       Reserve2 : Array[1..60] of Byte;
      End;

     Pal256 = Array[0..255] Of RGB;

     LineVideo = Array[0..PPLMax-1] Of Byte;  { jusqu' 32768 pixels/ligne ! }

     PLineVideo = ^LineVideo;

     MarkerRec = Record
       Buf    : Array[0..LgBufMax-1] Of Byte;  { buffer pour acclerer }
       LgBuf  : Word;         { nombre dans le buffer }
       iRead  : Word;         { position de lecture du buffer }
       CCode  : Byte;         { dernier code lu }
       NbRep  : Byte;         { nombre de repetition sur ce code }
      End;

     LevArray = Array[0..PPLMax-1] Of Longint;
     PLevArray= ^LevArray;

Const Palette16 : Pal16 = (
        ( Red:$00; Green:$00; Blue:$0E ),
        ( Red:$00; Green:$52; Blue:$07 ),
        ( Red:$2C; Green:$00; Blue:$0E ),
        ( Red:$00; Green:$00; Blue:$00 ),
        ( Red:$F8; Green:$01; Blue:$2C ),
        ( Red:$00; Green:$85; Blue:$0F ),
        ( Red:$42; Green:$00; Blue:$21 ),
        ( Red:$00; Green:$00; Blue:$00 ),
        ( Red:$00; Green:$00; Blue:$6A ),
        ( Red:$24; Green:$9B; Blue:$49 ),
        ( Red:$A1; Green:$5E; Blue:$90 ),
        ( Red:$5E; Green:$18; Blue:$5E ),
        ( Red:$84; Green:$14; Blue:$D9 ),
        ( Red:$95; Green:$A0; Blue:$14 ),
        ( Red:$12; Green:$00; Blue:$06 ),
        ( Red:$00; Green:$68; Blue:$1F )
       );

Var f         : File;         { source PCX }
    Head      : PCXHeadRec;   { en-tte }
    LgPal     : Word;         { nombre de couleurs }
    PalBW     : Array[0..255] Of Byte;
    xMax      : Word;
    yMax      : Word;
    xBPL      : Word;
    BPXMask   : Byte;
    BPXOfs    : Byte;
    Mark      : MarkerRec;

    dLg       : Word;
    dNb       : Word;

    gLine     : Word;         { n de la ligne (absolue)  lire }
    glv       : PLineVideo;
    gLev      : PLevArray;
    gResult   : PLineVideo;

    dLv       : Array[1..10+1] Of PLineVideo;

    vir       : Longint;

    rch       : Longint;     { rapport de conversion horizontal }
    rcv1      : Longint;     { rapport de conversion vertical 1 }
    rcv2      : Longint;     { ... 2 }
    rcv3      : Longint;     { et 3 }

    gBLarge   : Integer;

    NbPixels  : Array[0..7] Of Word;  { nombre de points du noir au blanc }

    MulmLg    : Byte;        { multiplicateur de mLg, en cas de "Largeur" }
    MulmNb    : Byte;        { idem, pour mNb, en cas de "Hauteur" }

    ScaleRo   : Byte;

    SemiMono  : Boolean;     { la conversion demand (semi-graph doit }
                             { tre lmentaire (noir & blanc) }

Procedure Color2BW( Var p );
Var Pal : Pal256 Absolute p;
    i : Byte;
Begin
 For i := 0 To LgPal-1 Do
  Begin
   PalBW[i] := (76*Word(Pal[i].Red)) Div 255+
               (151*Word(Pal[i].Green)) Div 255+
               (28*Word(Pal[i].Blue)) Div 255;
  End;
End;


Function OpenHeader : Boolean;
Var r       : Word;
    Mark    : Byte;
    i       : Byte;
    Pal     : ^Pal256;
Begin
 Assign(f,PCXName);
 Reset(f,1);
 If IoResult=0 Then
  Begin
   BlockRead(f,Head,sizeof(Head),r);
   If (r=SizeOf(PCXHeadRec)) And (Head.Marque=$0A) Then
    If (Head.Version>=2) Then
     If (Head.Codage=1) Then
      If (Head.BPX In [1,2,4,8]) And (Head.NbPlans In [1,2,4,8]) And
         (Head.BPX*Head.NbPlans<=8) Then
       Begin
        xMax   := (Head.XD-Head.XG)+1;
        yMax   := (Head.YB-Head.YH)+1;

        If (xMax>0) And (yMax>0) And (xMax<=PPLMax) Then
         Begin
          LgPal := 1 Shl (Head.BPX+Head.NbPlans-1);

          If (LgPal<256) And (LgPal In [2,4,16]) Then
           Begin
            If LgPal=2 Then
             Begin  { noir & blanc }
              PalBW[0] := 0;
              PalBW[1] := 255;
              xBPL := Head.BPL*8;
             End
            Else
             If LgPal=4 Then
              Begin
               PalBW[0] := 0;         { noir }
               PalBW[1] := 151;       { Turquoise/Vert }
               PalBW[2] := 76;        { Violet/Rouge }
               PalBW[3] := 255;       { Blanc/Jaune }
               xBPL := Head.BPL*8;
              End
             Else
              Begin
               If Head.Version<5 Then Color2BW(Palette16)
               Else Color2BW(Head.Palette);
               xBPL := Head.BPL*8;
              End;

            OpenHeader := TRUE;
            Exit;
           End
          Else
           If LgPal=256 Then
            Begin { 256 couleurs !!! }
             New(Pal);
             Seek(f,FileSize(f)-(SizeOf(Pal256)+1));
             BlockRead(f,Mark,SizeOf(Mark),r);
             If (r=SizeOf(Mark)) and (Mark=$0C) then
              Begin
               BlockRead(f,Pal^,SizeOf(Pal^),r);

               If r=SizeOf(Pal^) then
                Begin
                 Color2BW(Pal^);

                 Dispose(Pal);

                 xBPL := Head.BPL;

                 OpenHeader := TRUE;
                 Exit;
                End
               Else Writeln('Palette invalide');
              End
             Else Writeln('Palette 256 couleurs non trouve');
            End
           Else Writeln('nombre de couleurs (',LgPal,') non trait');
         End
        Else Writeln('rsolution invalide');
       End
      Else Writeln('organisation d''image non reconnue')
     Else Writeln('type de codage inconnu')
    Else Writeln('version non reconnue')
   Else Writeln('fichier PCX non reconnu');

   Close(f);

  End
 Else Writeln('Ouverture de ''',PCXName,''' impossible');
 OpenHeader := FALSE;
End;


Procedure LoadBuf;
Begin
 BlockRead(f,Mark.Buf,sizeof(Mark.Buf),Mark.LgBuf);
 Mark.iRead := 0;
End;


Function  ReadByte : Byte; Assembler;
Asm
    MOV  AL, [Mark.NbRep]
    OR   AL, AL
    JZ   @ICI
    DEC  AL
    MOV  [Mark.NbRep], AL
    MOV  AL, [Mark.CCode]
    JMP  @EXIT
@ICI:
    MOV  AX, [Mark.iRead]
    CMP  AX, [Mark.LgBuf]
    JB   @OK01
    CALL LoadBuf
@OK01:
    MOV  BX, [Mark.iRead]
    MOV  AL, BYTE [Mark.Buf+BX]
    INC  BX
    MOV  [Mark.iRead], BX

    MOV  AH, AL
    AND  AH, 192
    CMP  AH, 192
    JNZ  @PASREP
    AND  AL, (192 XOR 255)
    JZ   @ICI               { repart car NbRep=0 !!! }
    DEC  AL
    MOV  [Mark.NbRep], AL

    MOV  AX, [Mark.iRead]
    CMP  AX, [Mark.LgBuf]
    JB   @OK02
    CALL LoadBuf
@OK02:
    MOV  BX, [Mark.iRead]
    MOV  AL, BYTE [Mark.Buf+BX]
    INC  BX
    MOV  [Mark.iRead], BX

    MOV  [Mark.CCode], AL
    JMP  @EXIT
@PASREP:
    MOV  [Mark.CCode], AL
    MOV  [Mark.NbRep], 0
@EXIT:
End;


Procedure JumpLV;
Var nX    : Word;
    nPlan : Word;
    iCode : Byte;
Begin
 For nPlan := 1 To Head.NbPlans Do
  Begin
   iCode := 0;
   For nX := 0 To xBPL-1 { xMax-1 } Do
    Begin
     If iCode=0 Then ReadByte;
     Inc(iCode,Head.BPX);
     If iCode=8 Then iCode := 0;
    End;
  End;

End;



Procedure ReadLV; Assembler;
Var nX    : Word;
    nPlan : Byte;
    code  : Byte;
    iCode : Byte;
Asm
    CLD
    MOV  CX, [gLg]
    LES  DI, [glv]
    XOR  AL, AL
    REP  STOSB

    MOV  AX, [gLine]
    CMP  AX, [gNb]
    JB   @START
    JMP  @RIEN

    { ----- }

@START:
    MOV  [nPlan], 0

@BIGLOOP:

    MOV  [iCode], 0

    { ----- }

    MOV  CX, [gX]
    JCXZ @EXIT01
    MOV  AL, [iCode]
    MOV  AH, [Head.BPX]
@BOUCLE01:
    OR   AL, AL
    JNZ  @LA01
    PUSH AX             { sauve }
    PUSH CX
    CALL ReadByte
    MOV  [Code], AL
    POP  CX
    POP  AX
@LA01:
    ADD  AL, AH
    CMP  AL, 8
    JB   @LOOP01
    XOR  AL, AL
@LOOP01:
    LOOP @BOUCLE01
    MOV  [iCode], AL
@EXIT01:

    { ----- }

    MOV  AX, [gLg]
    MOV  [nX], AX
    MOV  DL, [iCode]
    MOV  DH, [Head.BPX]
    LES  DI, [glv]
@BOUCLE02:
    OR   DL, DL
    JNZ  @LA02
    PUSH DX             { sauve }
    PUSH DI
    PUSH ES
    CALL ReadByte
    MOV  [code], AL
    POP  ES             { restore }
    POP  DI
    POP  DX
@LA02:
    MOV  AL, 8
    MOV  AH, DL
    ADD  AH, DH
    SUB  AL, AH

    MOV  CL, AL
    MOV  AL, [code]
    SHR  AL, CL
    AND  AL, [BPXMask]  { b }

    PUSH AX

    MOV  AL, [nPlan]
    MOV  CL, [BPXOfs]
    SHL  AL, CL
    MOV  CL, AL

    POP  AX

    SHL  AL, CL
    OR   BYTE [ES:DI], AL
    INC  DI

    ADD  DL, DH
    CMP  DL, 8
    JB   @LOOP02
    XOR  DL, DL
@LOOP02:
    DEC  [nX]
    JNZ  @BOUCLE02

    MOV  [iCode], DL

    { ------ }

{    MOV  CX, [xMax] }
    MOV  CX, [xBPL]
    SUB  CX, [gLg]
    SUB  CX, [gX]
    JCXZ @EXIT03
    MOV  AL, [iCode]
    MOV  AH, [Head.BPX]
@BOUCLE03:
    OR   AL, AL
    JNZ  @LA03
    PUSH AX             { sauve }
    PUSH CX
    CALL ReadByte
    MOV  [Code], AL
    POP  CX
    POP  AX
@LA03:
    ADD  AL, AH
    CMP  AL, 8
    JB   @LOOP03
    XOR  AL, AL
@LOOP03:
    LOOP @BOUCLE03
    MOV  [iCode], AL
@EXIT03:

    MOV  AL, [nPlan]
    INC  AL
    MOV  [nPlan], AL
    CMP  AL, [Head.NbPlans]
    JB   @BIGLOOP

    CMP  [Mark.NbRep], 0
    JE   @RIEN

    MOV  AL, [Mark.NbRep]
    MOV  [Mark.NbRep], AL
(*
    MOV  [Mark.NbRep], 0       { Remettre  Zro pour tre compatible }
                               { avec des bogues de certains fichiers PCX }
*)
    { ------ }

@RIEN:
    CLD
    MOV  CX, [gLg]
    LES  DI, [glv]
    MOV  BX, OFFSET PalBW
@BOUCLE04:
    MOV  AL, [ES:DI]
    XLAT
    STOSB
    LOOP @BOUCLE04


    Inc  [gLine];
End;


Procedure Prepare_Videotex;
Var rc  : Longint;
    rst : Longint;
    i   : Byte;
Begin

 if mX+mLg>40 then mLg := 40-mX;

 MulmLg := 1;
 MulmNb := 1;

 dLg := mLg*2;
 dNb := mNb*3;

 For i := 1 To 3 Do GetMem(dlv[i],SizeOf(dlv[i]^[0])*dLg);

 { prepare conversion }

 rch  := (gLg*65536) Div dLg;

 rc := (gNb*65536) Div mNb;  { rcv faux }

 rcv2 := (rc*4) Div 10;

 rst := rc-rcv2;

 rcv1 := rst div 2;
 rcv3 := rst-rcv1;


 For i := 0 To 7 Do NbPixels[i] := 0;

End;


Procedure ReadStart;
Var li  : Word;
    ro  : Byte;
Begin
 { recherche le debut  convertir }

 Seek(f,SizeOf(Head));

 FillChar(Mark,SizeOf(Mark),0);

 If gY>0 Then
  Begin
   Write('Recherche du dbut de l''image ...  ');
   ro := 0;

   { on saute ce qui est exclu de l'image }

   li := 0;

   While (li<gY) Do
    Begin         { saute }
     JumpLV;
     If li Mod 32=0 Then
      Begin
       Write(#8+Roto[ro]);
       Inc(ro);
       If ro>=4 Then ro := 0;
      End;
     Inc(li);
    End;

   ClrLine;
  End;

End;


Procedure ReadInit;
Begin
 SemiMono := Abs(gBLo-gBHi)<=1;
 gBLo := (Longint(gBLo)*255) Div 100;
 gBHi := (Longint(gBHi)*255) Div 100;

 gBLarge := gBHi-gBLo;

 If gBLarge=0 Then
  Begin  { corrige la largeur de bande }
   gBLarge := 1;
   Inc(gBHi);
  End;

 BPXMask  := (1 Shl (Head.BPX))-1;
 BPXOfs   := Head.BPX Div 2;

 If gX>=xMax Then gX := xMax-1;
 If gY>=yMax Then gY := yMax-1;
 If gLg<0 Then gLg := xMax+gLg-gX;
 If gNb<0 Then gNb := yMax+gNb-gY;
 If gLg<0 Then gLg := 1
 Else If gLg>=xMax Then gLg := xMax;
 If gNb<0 Then gNb := 1
 Else If gNb>=yMax Then gNb := yMax;
 If gX+gLg>=xMax Then gLg := xMax-gX;
 If gY+gNb>=yMax Then gNb := yMax-gY;

 gLine := 0;

 vir := 0;

 GetMem(glv,SizeOf(glv^[0])*gLg);
 GetMem(gLev,SizeOf(gLev^[0])*gLg);
 GetMem(gResult,SizeOf(gResult^[0])*gLg);

 If mX>=40 then mX := 0;
 If mY>=25 then mY := 0;
 If mLg=0 Then mLg := 1;
 If mNb=0 Then mNb := 1;

 ScaleRo := 0;
End;





Procedure ScaleLV( Var src : LineVideo; Var dst : LineVideo; rch : Longint );
Var ir   : Longint;
    i    : Word;
    lev  : Longint;
    lu   : Longint;
    cqr  : Longint;
Begin
 ir := 0;

 For i := 0 To dLg-1 Do
  Begin
   lev := 0;
   lu  := 0;

   Repeat

    If LongRec(ir).Lo<>0 Then cqr := 65536-LongRec(ir).Lo
    Else
     If rch<=65536 Then cqr := rch
     Else cqr := 65536;

    If lu+cqr>rch Then cqr := rch-lu;

    Inc(lev,(Longint(src[LongRec(ir).Hi]))*cqr);
    Inc(lu,cqr);
    Inc(ir,cqr);

   Until lu>=rch;

   dst[i] := lev Div lu;
  End;
End;



Procedure ScaleReadLV( rcv : Longint );
Var lu  : Longint;
    cqr : Longint;
    i   : Word;
Begin
 Write(#8,Roto[ScaleRo]);
 Inc(ScaleRo);
 If ScaleRo>=4 Then ScaleRo := 0;

 Asm
     CLD
     MOV  CX, [gLg]
     SHL  CX, 1
     LES  DI, [gLev]
     XOR  AX, AX
     REP  STOSW
 End;


 lu := 0;

 Repeat
  If LongRec(vir).Hi=gLine Then ReadLV;

  If LongRec(vir).Lo<>0 Then cqr := 65536-LongRec(vir).Lo
  Else
   If rcv<=65536 Then cqr := rcv
   Else cqr := 65536;

  If lu+cqr>rcv Then cqr := rcv-lu;

  Asm
      MOV  AX, [gLg]
      MOV  [i], AX

      PUSH DS

      LES  DI, [glev]
      LDS  SI, [glv]

  @BOUCLE:
      MOV  AL, [SI]
      XOR  AH, AH
      XOR  DX, DX
      MOV  CX, WORD [cqr]
      MOV  BX, WORD [cqr+2]

      PUSH SI
      PUSH DI

      MOV  SI, AX
      MOV  DI, DX
      MUL  CX
      PUSH AX
      PUSH DX
      MOV  AX, SI
      MUL  BX
      MOV  BX, AX
      MOV  AX, DI
      MUL  CX
      MOV  CX, AX
      POP  DX
      POP  AX
      ADD  DX, BX
      ADD  DX, CX

      POP  DI
      POP  SI

      ADD  WORD [ES:DI], AX
      ADC  WORD [ES:DI+2], DX
      ADD  DI, 4

      INC  SI

      DEC  [i]
      JNZ  @BOUCLE

      POP  DS
  End;

  Inc(lu,cqr);
  Inc(vir,cqr);

 Until lu>=rcv;

 For i := 0 To gLg-1 Do
  gResult^[i] := gLev^[i] Div lu;

End;


{***********************************
 *                                 *
 *    Code PCX  =>  Semi-Graph.    *
 *                                 *
 ***********************************}


Procedure Load3Lines;
Begin
 { 1 }
 ScaleReadLV(rcv1);
 ScaleLV(gResult^,dlv[1]^,rch);

 { 2 }
 ScaleReadLV(rcv2);
 ScaleLV(gResult^,dlv[2]^,rch);

 { 3 }
 ScaleReadLV(rcv1);
 ScaleLV(gResult^,dlv[3]^,rch);

End;


Type CarDef = Array[0..5] Of Byte;

Var
    ca        : CarDef;

    col       : Byte;

Procedure ChargeCa;
Var i  : Byte;
    a  : Longint;
    b  : Longint;
Begin
 For i := 0 To 5 Do
  Begin
   a := dlv[(i Div 2)+1]^[(col*2)+(i And 1)];

   { fentre de lumire }

   a := ((a-Longint(gBLo))*255) Div gBLarge;

   If a<0 Then a := 0
   Else
    If a>255 Then a := 255;

   { distorsion }

   b := 16384-(((a*a)+16129-254*a));

   b := (b*255*Longint(gLux)) Div (100*16384);

   Inc(a,b);

   if a<0 then a := 0
   else
     if a>255 then a := 255;

   ca[i] := a;
  End;
End;


procedure PoliCa;
type XCaseRec = record
         NbCases : byte;
         Cases   : array[0..5] of byte;
       end;

     XTabCase = array[0..7] of XCaseRec;


     XTabCoul = array[0..5] of byte;

var TabCase : XTabCase;
    TabCoul : XTabCoul;
    NbCoul  : word;

  procedure StatZ;
  var coul      : word;
      i         : word;
      best      : word;
      j         : word;
      ResteCases : word;
  begin
    for i := 0 to 7 do TabCase[i].NbCases := 0;

    for i := 0 to 5 do
      begin
        coul := (ca[i]*8) div 255;
        if coul>=8 then coul := 7;
        TabCase[coul].Cases[TabCase[coul].NbCases] := i;
        inc(TabCase[coul].NbCases);
      end;

    { trie }

    NbCoul     := 0;
    best       := 6;
    ResteCases := 6;

    while ResteCases>0 do
      begin
        for i := 7 downto 0 do
          if TabCase[i].NbCases=best then
            begin
              dec(ResteCases,best);
              TabCoul[NbCoul] := i;  { note le n du tableau }
              inc(NbCoul);
            end;
        dec(best);
      end;
  end;

var som : word;
    a   : word;
    moy : word;
    i   : word;
    j   : word;
    t   : word;
    n   : word;
label la;
begin
la:
  StatZ;
  if (NbCoul>=3) and (NbCoul<=5) then
    begin
      a := 0;
      som := 0;
      for i := 1 to NbCoul-1 do
        begin
          n := TabCoul[i];
          for j := 0 to TabCase[n].NbCases-1 do
            begin
              t := TabCase[n].Cases[j];
              inc(som,ca[t]);
              inc(a);
            end;
        end;

      moy := som div a;
      for i := 1 to NbCoul-1 do
        begin
          n := TabCoul[i];
          for j := 0 to TabCase[n].NbCases-1 do
            begin
              t := TabCase[n].Cases[j];
              ca[t] := moy;
            end;
        end;
    end
  else
    if NbCoul=6 then
      begin
        moy := (ca[2]+ca[3]) div 2;
        ca[2] := moy;
        ca[3] := moy;
        goto la;
      end;
end;


function AjustCom : boolean;
const TabComIrq : array[1..4] of byte = (4,3,4,3);
begin
  if (nCom=0) then AjustCom := TRUE
  else
    if nCom<=4 then
      begin
        AjustCom := FALSE;

        if Adr=0 then
          begin
            Adr := memw[$40:(nCom-1)*2];
            if Adr=0 then
              begin
                writeln('Pas de carte srie');
                exit;
              end;
          end;

        if Irq=0 then Irq := TabComIrq[nCom]
        else
          if (Irq<0) or (Irq>15) then
            begin
              writeln('Irq invalide');
              exit;
            end;

        if LgOut<0 then LgOut := 0;

        AjustCom := TRUE;
      end
    else writeln('Numro de COM incorrecte');
end;


Procedure WriteCom( texte : String );
begin
 if nCom>0 then Mntl.Write(texte);
End;




Procedure WaitOutEmpty;
Var ro : Byte;
    tx : Longint;
    h  : Word;
Begin
 If (nCom>0) And (Mntl.TransmitCount>0) Then
  Begin
   ro := 0;
   tx := 0;
   h  := 0;

   While Mntl.TransmitCount>0 Do
    Begin
     If tx<=GetC18 Then
      Begin
       Inc(ro);
       If ro>=4 Then ro := 0;
       tx := GetC18+(18 Div 2);
       Inc(h);
       If h>=2 Then
        Begin
         If h=2 Then
          Begin
           ClrLine;
           Write('Vide tampon de communication ...  ');
          End;
         Write(#8+Roto[ro]);
        End;
      End;
    End;

   ClrLine;
  End;
End;


Var SaveExitCom : Pointer;

procedure FinCom;
begin
 If nCom>0 then
  Begin
   WriteCom(#27#57#$7F);   { Reset }
   WaitOutEmpty;
   ExitProc := SaveExitCom;
   MinRestoreSpeed;
   Mntl.Done;
  End;
end;


Procedure ExitCom; Far;
Begin
 If nCom>0 Then
  Begin
   ExitProc := SaveExitCom;
   Mntl.TransmitClear;
   FinCom;
  End;
End;


procedure DebutCom;
Var org : Word;
    how : Word;
    Par : Word;
begin
 if nCom>0 then
  Begin
   Par := ComPar;
   If ComPar=ParUndef Then Par := Par7Bits;
   If Not(Mntl.Init(Adr,Irq,TabSpeed[Speed].BD,Par,128,LgOut)) Then
    Begin
     Writeln('Impossible d''ouvrir le comunication');
     Halt(1);
    End;

   SaveExitCom := ExitProc;
   ExitProc := @ExitCom;

   If Not(Silence) Then
    Begin
     Write('Dtection du minitel ...  ');
     org := Speed;
     how := MinDetect(Speed,FALSE,TRUE);
     Write(#8);
     If how=$FFFF Then
      Begin
       Writeln('NON DETECTE !!!   (Utilisez l''option /SIL)');
       Mntl.SetBaud(TabSpeed[Speed].BD);
      End
     Else
      Begin
       If org<>Speed Then
        Begin
         Writeln('vitesse possible: ',115200 Div TabSpeed[Speed].BD,' BAUDS');
        End
       Else
        If how>0 Then
         Begin
          Writeln('vitesse modifie: adaptation manuelle recommande');
         End
        Else ClrLine;
      End;
    End;

   WriteCom(#27#57#$7F#17);    { Reset+Allume curseur }
  End;
end;


procedure EnvoiCom( texte : string );
begin
  WriteCom(texte);
  FRam.Write(texte);
end;


procedure MiniCar( var g : byte; var Trait, Fond : byte);
var i    : word;
    coul : word;
    t    : byte;
    f    : byte;
    z    : byte;
    Find : boolean;
begin
  t := (ca[0]*8) div 255;
  if t>=8 then t := 7;
  f := t;
  z := 32;
  for i := 1 to 5 do
    begin
      coul := (ca[i]*8) div 255;
      if coul>=8 then coul := 7;
      if t=coul then z := (z shr 1) or 32
      else
        begin
          f := coul;
          z := z shr 1;
        end;
    end;


  g     := z;
  Trait := t;
  Fond  := f;
end;



Procedure FlushWait;
Var s : String;
Begin
 FlushTrans(VD,s);
 EnvoiCom(s);
End;


Procedure ToMinitel( y : Byte);
var g, Trait, Fond, Tempo : byte;
    s  : string;
    nc : word;
    i  : Byte;
    wt : Byte;
    wf : Byte;
    wg : Byte;
begin
  MiniCar(g,Trait,Fond);

  If SemiMono Then
   Begin { il ne doit rest que Noir et Blanc }
    Trait := (Trait Div 4)*7;
    Fond  := (Fond Div 4)*7;
    If Trait<Fond Then
     Begin
      Tempo := Trait;
      Trait := Fond;
      Fond  := Tempo;
      g     := g xor 63;
     End;
   End;

  { compte les pixels ... }
  nc := 0;
  For i := 0 To 5 Do Inc(nc,(g Shr i) And 1);
  Inc(NbPixels[Trait],nc);
  Inc(NbPixels[Fond],6-nc);

  If Not(SemiMono) Then
   Begin
    If OptGraphik And (g=63) Then
     Begin
      g := g xor 63;
      Tempo := Fond;
      Fond  := Trait;
      Trait := Tempo;
     End;

    If VD.Wait.Nb>0 Then
     Begin
      wt := VD.Wait.CurAtt And 7;
      wf := (VD.Wait.CurAtt Shr 3) And 7;
      wg := Byte(VD.Wait.Car);

      If wg>=96 Then Dec(wg,64)
      Else Dec(wg,32);

      If g=0 Then Trait := wt;

      If ((wt<>Trait) and (wf<>Fond)) and
         ((wt=Fond) or (wf=Trait) or (wg=g xor 63)) then
        begin { inverse }
          g     := g xor 63;
          Tempo := Trait;
          Trait := Fond;
          Fond  := Tempo;
        end;

     End;
   End;

  If OptWithVide And
     (((g=0) And (Fond=0)) Or
      ((g=63) And (Trait=0))) Then g := 0
  Else
   Begin
    Inc(g,32);
    If g>=64 Then
     Begin
      Inc(g,32);
      If g=127 Then g := 95;
     End;
   End;

  TransCode(VD,mX+col,y,Char(g),Trait+(Fond Shl 3)+Stable+Graphik,s);
  EnvoiCom(s);
End;


procedure HautBas;
var s   : String;
    lig : Integer;
    yr  : Byte;
    l   : Byte;
    i   : Byte;
begin
  write(' Ligne n');
  for lig := mY to mY+(mNb-1) do
    begin
      s := ValStr(lig,0)+'  ('+ValStr((lig-mY)+1,0)+'/'+ValStr(mNb,0)+')   ';
      l := Length(s);
      Write(s);
      If lig<=ScreenHigh-1 Then yr := lig
      Else
       Begin
        yr := ScreenHigh-1;

        If ModeScroll Then
         If VD.NextLn=0 Then
          Begin
           TransCodeScrollUp(VD,s);
           EnvoiCom(s);
          End
         Else
          Begin
           FlushTrans(VD,s);
           EnvoiCom(s);
           If VD.UseCAN Then
            Begin
             TransCodeScrollUp(VD,s);
             EnvoiCom(s);
            End;
          End;

       End;

      Load3Lines;  { charge les 3 lignes graphiques suivantes }

      For col := 0 To mLg-1 Do
       Begin
        ChargeCa;
        PoliCa;
        ToMinitel(yr);
       End;

     For i := 1 To l Do Write(#8);

    end;
  write(#8#8#8#8#8#8#8#8#8);
end;

{***********************************
 *                                 *
 *    Code PCX  =>  D R C S        *
 *                                 *
 ***********************************}


Procedure WriteTeleGX( Var Tel : RamFile );
Var i, j : Byte;
    Need1FZZ : Boolean;
Begin
 Need1FZZ := FALSE;
 For j := 0 To 1 Do
  Begin
   If TabG[j].Read>TabG[j].iRead Then
    Begin
     If j=0 Then Tel.Write(TeleG0) Else Tel.Write(TeleG1);
     Tel.Write(#$1F+#$23+Char(TabG[j].First+33+TabG[j].iRead));
     For i := TabG[j].iRead+1 To TabG[j].Read Do
      Begin
       Tel.Write(#$30+CodeMatrice(RamDRCS^[j,i-1]));
      End;
     TabG[j].iRead := TabG[j].Read;
     Need1FZZ := TRUE;
    End;
  End;
 If Need1FZZ Then Tel.Write(#$1F'ZZ');
End;


{ Efface les jeux qui vont tre utiliss }
{ (effet local!) }

Procedure ClrJeuxDRCS;
Var i, j : Byte;
Begin
 For j := 0 To 1 Do
  Begin
   If TabG[j].Nb>0 Then
    Begin
     If j=0 Then WriteCom(TeleG0) Else WriteCom(TeleG1);
     WriteCom(#$1F+#$23+Char(TabG[j].First+33));
     For i := 1 To TabG[j].Nb Do WriteCom(#$30);
    End;
  End;
 WriteCom(#$1F'ZZ');
End;


{ Efface les jeux utiliss }

Procedure ClrTeleGX( Var Tel : RamFile );
Var i, j : Byte;
    Need1FZZ : Boolean;
Begin
 Need1FZZ := FALSE;
 For j := 0 To 1 Do
  Begin
   If TabG[j].Read>0 Then
    Begin
     If j=0 Then Tel.Write(TeleG0) Else Tel.Write(TeleG1);
     Tel.Write(#$1F+#$23+Char(TabG[j].First+33));
     For i := 1 To TabG[j].Read Do Tel.Write(#$30);
     Need1FZZ := TRUE;
    End;
  End;
 If Need1FZZ Then Tel.Write(#$1F'ZZ');
End;


Const
      Mat20    : MinMatrice = (0,0,0,0,0,0,0,0,0,0);
      Mat7F    : MinMatrice = (255,255,255,255,255,255,255,255,255,255);

      Pix20    : Byte = 0;
      Pix7F    : Byte = 80;

Const TpJeu_NIL   = 0;
      TpJeu_G0    = 1;
      TpJeu_G1    = 2;
      TpJeu_G1D   = 3;
      TpJeu_G2    = 4;
      TpJeu_G2B   = 5;
      TpJeu_20    = 6;
      TpJeu_7F    = 7;
      TpJeu_DRCS0 = 8;
      TpJeu_DRCS1 = 9;


Var NbG012    : Word;
    PixTotal  : Longint;
    PixOk     : Longint;
    NeedProche: Boolean;

    Stock     : RamFile;

    NbFreeDRCS  : Word;
    NbWantDRCS  : Word;
    PErr        : Word;

Function GWhat( Car : Char ) : Word;
Type WordRec = Record
       Lo, Hi : Byte;
      End;
Var s : String[1];
    d : String[3];
    c : Byte;
    g : Byte;
    x : Word;
Begin
 If (Car=#0) Or (Car=Char(Complement)) Then x := 0
 Else
  Begin
   s := Car;
   IbmVdt(s,d);
   If d='' Then d := ' ';
   If d[1]>=#32 Then
    Begin
     WordRec(x).Lo := TpJeu_G0;
     WordRec(x).Hi := Byte(d[1])-31;
    End
   Else
    Begin
     c := InRang(Accent,5,Byte(d[2]));
     If c>0 Then
      Begin
       g := InRang(Voyelle,5,Byte(d[3]));
       If g>0 Then
        Begin
         WordRec(x).Lo := TpJeu_G2B;
         WordRec(x).Hi := ((c-1)*5)+g;
        End
       Else
        If d[3]='c' Then
         Begin
          WordRec(x).Lo := TpJeu_G2B;
          WordRec(x).Hi := C_CEDILLE+1;
         End
        Else
         Begin
          WordRec(x).Lo := TpJeu_G0;
          WordRec(x).Hi := Byte(d[3])-31;
         End;
      End
     Else
      Begin
       c := InRang(SS2,LgG2,Byte(d[2]));
       If c>0 Then
        Begin
         WordRec(x).Lo := TpJeu_G2;
         WordRec(x).Hi := c;
        End
       Else
        Begin
         WordRec(x).Lo := TpJeu_G0;
         WordRec(x).Hi := 1;
        End;
      End;
    End;
  End;
 GWhat := x;
End;


Procedure Prepare_DRCS;
Var rc  : Longint;
    rst : Longint;
    i   : Byte;
    x   : Word;
Begin
 NbG012     := 0;
 PixTotal   := 0;
 PixOk      := 0;
 NeedProche := FALSE;

 If BWMode>0 Then BWMode := Default_BWMode;
 If BWPiv>100 Then BWPiv := Default_BWPiv;
 If BWProp>100 Then BWProp := Default_BWProp;

 BWPiv  := (BWPiv*63) Div 100;   { pivot rel }
 BWProp := (BWProp*16) Div 100;  { proportion rel }

 If ProcheErr>100 Then ProcheErr := 100;
 ProcheErr := 80-((ProcheErr*80) Div 100);

 For i := 0 To 1 Do
  Begin
   If TabG[i].First>=GCharMax Then TabG[i].First := 0;
   If TabG[i].First+TabG[i].Nb>GCharMax Then TabG[i].Nb := GCharMax-TabG[i].First;
   TabG[i].Read  := 0;
   TabG[i].iRead := 0;
  End;

 If ModeTele>MT_Disjoint Then
  Begin
   ModeTele := Default_MT;
   ParamTele := Default_MTParam;
  End;

 If CTrait>7 Then CTrait := Default_CT;
 If CFond>7 Then CFond := Default_CF;

 If G0Taille>T_Double Then G0Taille := T_Normale;
 If (RDX>8) Or Not(RDX In [8,4,2,1]) Then RDX := Default_RDX;
 If (RDY>10) Or Not(RDY In [10,5,2,1]) Then RDY := Default_RDY;

 If G0Taille And T_Large=0 Then MulmLg := 1 Else MulmLg := 2;

 If mX+mLg*MulmLg>40 Then
  Begin
   mLg := (40-mX) Div MulmLg;
   If mLg=0 Then mLg := 1;
  End;

 If G0Taille And T_Haute=0 Then MulmNb := 1 Else MulmNb := 2;

 dLg := RDX*mLg;
 dNb := RDY*mNb;

 For i := 1 To RDY+1 Do GetMem(dlv[i],SizeOf(dlv[i]^[0])*dLg);

 { prepare conversion }

 TailleProp := TailleProp And (G0Taille And T_Haute<>0) And (RDY=10);

 rch  := (gLg*65536) Div dLg;

 If TailleProp Then
  Begin  { proportionner les tailles de lignes }
   rc := (gNb*65536) Div dNb;

   rcv1 := rc+(rc Div 2);

   rcv2 := rc;

   rcv3 := rc Div 2;

  End
 Else rcv1 := (gNb*65536) Div dNb;

 If (GCTable=NIL) Or (GCTable^.Table='') Then
  Begin
   LgGC := 0;
   GC   := NIL;
  End
 Else
  Begin
   LgGC := Length(GCTable^.Table);
   GetMem(GC,SizeOf(GC^[1])*LgGC);
   For i := 1 To LgGC Do
    Begin
     x := GWhat(GCTable^.Table[i]);
     GC^[i] := x;
    End;
  End;

 If (GCPTable=NIL) Or (GCPTable^.Table='') Then
  Begin
   LgGCP := 0;
   GCP   := NIL;
  End
 Else
  Begin
   LgGCP := Length(GCPTable^.Table);
   GetMem(GCP,SizeOf(GCP^[1])*LgGCP);
   For i := 1 To LgGCP Do
    Begin
     x := GWhat(GCPTable^.Table[i]);
     GCP^[i] := x;
    End;
  End;

 NbFreeDRCS := TabG[0].Nb+TabG[1].Nb;
 NbWantDRCS := mLg*mNb;

End;




Var Mat : MinMatrice;
    Pix : Byte;          { nombre de pixels }

    CodeZ    : Byte;     { codeZ, relatif  un tableau... }
    AttZ     : Word;     { attribut videotex (de base) }
    NewZ     : Boolean;
    JeuZ     : Byte;     { pris en compte que si AttZ And DRCS=0 }
    PixZ     : Byte;     { nombre de pixels valide (max:80) }


{ charge la matrice courante (en fonction de col) }

Procedure ChargeMat;
Var x, y, z : Byte;
    l       : Byte;
    h, p    : Byte;
    lv      : PLineVideo;
    g       : Word;
    r       : Byte;
Begin
 CodeZ := 32;            { par dfaut, en cas d'erreur affiche "?" }
 AttZ  := 0;
 NewZ  := FALSE;
 JeuZ  := TpJeu_G0;
 PixZ  := 0;             { soyons optimiste... }

 Pix := 0;

 l   := 1;
 lv  := dLv[1];
 p   := 10 Div RDY;
 h   := p;

 g   := col*RDX;

 For y := 0 To 9 Do
  Begin

   z := 0;

   r := 0;

   For x := 0 To 7 Do
    Begin
     z := (z Shl 1) or (lv^[g+(r Div 8)]);
     If z And 1<>0 Then Inc(Pix);
     Inc(r,RDX);
    End;

   Mat[y] := z;

   Dec(h);
   If h=0 Then
    Begin
     Inc(l);
     lv := dLv[l];
     h := p;
    End;

  End;

 Inc(PixTotal,10*8);

 If OptProcheMax And (NbFreeDRCS=0) Then
  Begin
   NeedProche := TRUE;
   OptProche  := TRUE;
  End;

 If ProcheVar Then
  Begin
   g := ProcheErr+((80-ProcheErr)*NbFreeDRCS) Div NbWantDRCS;
   If g>80 Then g := 80;
   PErr := g;
  End
 Else PErr := ProcheErr;

 Dec(NbWantDRCS);
End;


{ renvoi, n+1 (n=position dans le tableau) }

Function SeekMat( Var p; Var px; Lg : Byte; Att : Word; TpJeu : Byte; Add : Byte ) : Boolean;
Var Jeu : Array[0..255] Of MinMatrice Absolute p;
    zz  : Array[0..255] Of Byte Absolute px;
    i   : Byte;
    m   : PMinMatrice;
    zzz : Byte;
    SkInv : Boolean;
    Find  : Boolean;
Begin
 SkInv := OptInverse And (Att And Inverse<>0);
 For i := 1 To Lg Do
  Begin
   zzz := zz[i-1];
   m   := @Jeu[i-1];
   If (Pix=zzz) Then
    Begin
     Asm
         MOV  CX, 5
         MOV  SI, OFFSET Mat
         LES  DI, [m]
         CLD
         REPE CMPSW
         JE   @EGAL
         MOV  [Find], FALSE
         JMP  @FIN
     @EGAL:
         MOV  [Find], TRUE
     @FIN:
     End;
     If Find Then
      Begin { Trouv ! }
       CodeZ   := i+Add;
       AttZ    := Att And Not(Inverse);
       JeuZ    := TpJeu;
       PixZ    := 80;
       SeekMat := TRUE;
       Exit;
      End;
    End;
   If SkInv And (Pix=80-zzz) Then
    Begin
     Asm
         MOV  CX, 5
         MOV  SI, OFFSET Mat
         LES  DI, [m]
         CLD
     @BOUCLE:
         LODSW
         NOT  AX
         MOV  BX, [ES:DI]
         INC  DI
         INC  DI
         CMP  AX, BX
         LOOPE @BOUCLE
         JE   @EGAL
         MOV  [Find], FALSE
         JMP  @FIN
     @EGAL:
         MOV  [Find], TRUE
     @FIN:
     End;
     If Find Then
      Begin { Trouv ! }
       CodeZ   := i+Add;
       AttZ    := Att;
       JeuZ    := TpJeu;
       PixZ    := 80;
       SeekMat := TRUE;
       Exit;
      End;
    End;
  End;
 SeekMat := FALSE;
End;


Function FindBestDRCS : Boolean;
Begin
 FindBestDRCS := SeekMat(RamDRCS^[0],TabG[0].TabPix,
                         TabG[0].Read,DRCS+Inverse,TpJeu_DRCS0,0) Or
                 SeekMat(RamDRCS^[1],TabG[1].TabPix,
                         TabG[1].Read,DRCS+Graphik,TpJeu_DRCS1,0);
End;


Function FindBestG0G2 : Boolean;
Var i    : Byte;
    x    : Word;
    j    : Byte;
    Ok   : Boolean;
Begin
 If (GC<>NIL) And (LgGC>0) Then
  Begin
   For i := 1 To LgGC Do
    Begin
     x := GC^[i];
     If x<>0 Then
      Begin
       j := Hi(x)-1;
       Case Lo(x) Of
        TpJeu_G0  : Ok := SeekMat(JeuG0[j],PixJeuG0[j],1,Inverse,TpJeu_G0,j);
        TpJeu_G2  : Ok := SeekMat(JeuG2[j],PixJeuG2[j],1,Inverse,TpJeu_G2,j);
        TpJeu_G2B : Ok := SeekMat(JeuG2B[j],PixJeuG2[j],1,Inverse,TpJeu_G2B,j);
       Else Ok := FALSE;
       End;
       If Ok Then
        Begin
         FindBestG0G2 := TRUE;
         Exit;
        End;
      End;
    End;
   FindBestG0G2 := FALSE;
  End
 Else
  FindBestG0G2 := SeekMat(JeuG0[1],PixJeuG0[1],LgG0-2,Inverse,TpJeu_G0,1) Or
                  SeekMat(JeuG2,PixJeuG2,LgG2,Inverse,TpJeu_G2,0) Or
                  SeekMat(JeuG2B,PixJeuG2B,LgG2B,Inverse,TpJeu_G2B,0);
End;


{ Recherche si un dessin des jeux standard est identique }

Function FindBestDRCSMixte : Boolean;
Begin
 FindBestDRCSMixte := (CanUseG1 And
                       (SeekMat(JeuG1,PixJeuG1,LgG1,Graphik,TpJeu_G1,0) Or
                       (CanUseG1D And
                        SeekMat(JeuG1D,PixJeuG1D,LgG1,Graphik+Disjoint,TpJeu_G1D,0)))) Or
                      (CanUseG0G2 And FindBestG0G2);
End;



{ compare la matrice courante, et celle propos }
{ et renvoi un nombre de concordance }

Function CompareMat( Var m : MinMatrice; Inv : Boolean ) : Byte; Assembler;
Asm
    CLD
    MOV  SI, OFFSET Mat
    LES  DI, [m]
    MOV  DL, 5
    XOR  BL, BL
@BOUCLE:
    LODSW
    XOR  AX, [ES:DI]
    CMP  [Inv], FALSE
    JNE  @CONT
    NOT  AX
@CONT:
    MOV  CX, 16
@BNorm:
    ROL  AX, 1
    ADC  BL, 0
    LOOP @BNorm
    INC  DI
    INC  DI
    DEC  DL
    JNZ  @BOUCLE
    MOV  AL, BL
End;


Procedure DecaleMatLeft( Var msrc : MinMatrice; Var Dest : MinMatrice ); Assembler;
Asm
    PUSH DS
    LDS  SI, [msrc]
    LES  DI, [dest]
    CLD
    MOV  CX, 10
@BOUCLE:
    LODSB
    SHL  AL, 1
    STOSB
    LOOP @BOUCLE
    POP  DS
End;


Procedure DecaleMatRight( Var msrc : MinMatrice; Var Dest : MinMatrice ); Assembler;
Asm
    PUSH DS
    LDS  SI, [msrc]
    LES  DI, [dest]
    CLD
    MOV  CX, 10
@BOUCLE:
    LODSB
    SHR  AL, 1
    STOSB
    LOOP @BOUCLE
    POP  DS
End;


Procedure DecaleMatUp( Var msrc : MinMatrice; Var Dest : MinMatrice ); Assembler;
Asm
    PUSH DS
    LDS  SI, [msrc]
    INC  SI
    LES  DI, [dest]
    CLD
    MOV  CX, 9
    REP  MOVSB
    MOV  [BYTE PTR ES:DI], 0
    POP  DS
End;

Procedure DecaleMatDown( Var msrc : MinMatrice; Var Dest : MinMatrice ); Assembler;
Asm
    PUSH DS
    LDS  SI, [msrc]
    LES  DI, [dest]
    MOV  [BYTE PTR ES:DI], 0
    INC  DI
    CLD
    MOV  CX, 9
    REP  MOVSB
    POP  DS
End;


Function  ExtendedCompareMat( Var msrc : MinMatrice; Inv : Boolean ) : Integer;
Var m  : MinMatrice;
    m2 : MinMatrice;
    sc : Byte;
    BScore : Integer;
    nc : Byte;
    h  : Byte;
    t  : Word;
Begin
 nc := CompareMat(msrc,Inv);
 h  := 0;
 t  := 0;

 DecaleMatUp(msrc,m);
 sc := CompareMat(m,Inv);
 If sc>=nc Then
  Begin
   Inc(h);
   Inc(t,sc);
  End;

 DecaleMatLeft(m,m2);
 sc := CompareMat(m2,Inv);
 If sc>=nc Then
  Begin
   Inc(h);
   Inc(t,sc);
  End;

 DecaleMatRight(m,m2);
 sc := CompareMat(m2,Inv);
 If sc>=nc Then
  Begin
   Inc(h);
   Inc(t,sc);
  End;

 DecaleMatLeft(msrc,m);
 sc := CompareMat(m,Inv);
 If sc>=nc Then
  Begin
   Inc(h);
   Inc(t,sc);
  End;

 DecaleMatDown(m,m);
 sc := CompareMat(m,Inv);
 If sc>=nc Then
  Begin
   Inc(h);
   Inc(t,sc);
  End;

 DecaleMatRight(msrc,m);
 sc := CompareMat(m,Inv);
 If sc>=nc Then
  Begin
   Inc(h);
   Inc(t,sc);
  End;

 DecaleMatDown(m,m);
 sc := CompareMat(m,Inv);
 If sc>=nc Then
  Begin
   Inc(h);
   Inc(t,sc);
  End;

 DecaleMatDown(msrc,m);
 sc := CompareMat(m,Inv);
 If sc>=nc Then
  Begin
   Inc(h);
   Inc(t,sc);
  End;

 If h>0 Then
  Begin
   nc := (nc+t) Div (h+1);
  End;
 ExtendedCompareMat := nc;
End;


Type ProcheResult = Record
       CodeZ        : Byte;
       AttZ         : Word;
       TpJeu        : Byte;
       PixZ         : Byte;
       BScore       : Integer;
      End;


{ Renvoi ncar (Lo) et score (Hi) }

Procedure SeekProcheMat( Var PR : ProcheResult;
                         Var p; Var z; Lg : Byte; Att : Word; TpJeu : Byte;
                         Add : Byte );
Var Jeu : Array[0..255] Of MinMatrice Absolute p;
    JJ  : PMinMatrice;
    Px  : Array[0..255] Of Byte Absolute z;
    Pxx : Byte;
    i   : Byte;
    m   : PMinMatrice;
    BC  : Byte;
    BScore : Integer;
    BInv   : Boolean;
    sc  : Integer;
    zxNorm : Byte;
    zxInv  : Byte;
    SkInv  : Boolean;
Begin
 BC  := 0;
 BScore := 0;
 BInv := FALSE;

 zxNorm := Pix;
 zxInv := 80-Pix;
 SkInv := OptInverse And (Att And Inverse<>0);

 For i := 1 To Lg Do
  Begin
   JJ  := @Jeu[i-1];
   Pxx := Px[i-1];
   If NeedProche Or (80-Abs(Pxx-zxNorm)>=PErr) Then
    Begin
     If OptProchePoussee Then
      Begin
       sc := ExtendedCompareMat(JJ^,FALSE);
      End
     Else sc := CompareMat(JJ^,FALSE);
     If sc>BScore Then
      Begin
       BC := i;
       BScore := sc;
       BInv := FALSE;
      End;
    End;
   If SkInv Then
    Begin
     If NeedProche Or (80-Abs(Pxx-zxInv)>=PErr) Then
      Begin
       If OptProchePoussee Then
        Begin
         sc := ExtendedCompareMat(JJ^,TRUE);
        End
       Else sc := CompareMat(JJ^,TRUE);
       If sc>BScore Then
        Begin
         BC := i;
         BScore := sc;
         BInv := TRUE;
        End;
      End;
    End;
  End;

 If BScore>PR.BScore Then
  Begin
   PR.CodeZ  := BC+Add;
   If Not(BInv) Then Att := Att And Not(Inverse);
   PR.AttZ   := Att;
   PR.TpJeu  := TpJeu;
   PR.PixZ   := BScore;
   PR.BScore := BScore;
  End;

End;


Procedure FindProcheDRCS( Var pr : ProcheResult );
Begin
 SeekProcheMat(pr,RamDRCS^[0],TabG[0].TabPix,TabG[0].Read,DRCS+Inverse,TpJeu_DRCS0,0);
 SeekProcheMat(pr,RamDRCS^[1],TabG[1].TabPix,TabG[1].Read,Graphik+DRCS,TpJeu_DRCS1,0);
End;


Procedure FindProcheG0G2( Var pr : ProcheResult );
Var i    : Byte;
    x    : Word;
    j    : Byte;
Begin
 If (GCP<>NIL) And (LgGCP>0) Then
  Begin
   For i := 1 To LgGCP Do
    Begin
     x := GCP^[i];
     If x<>0 Then
      Begin
       j := Hi(x)-1;
       Case Lo(x) Of
        TpJeu_G0  : SeekProcheMat(PR,JeuG0[j],PixJeuG0[j],1,Inverse,TpJeu_G0,j);
        TpJeu_G2  : SeekProcheMat(PR,JeuG2[j],PixJeuG2[j],1,Inverse,TpJeu_G2,j);
        TpJeu_G2B : SeekProcheMat(PR,JeuG2B[j],PixJeuG2[j],1,Inverse,TpJeu_G2B,j);
       End;
      End;
    End;
  End
 Else
  Begin
   SeekProcheMat(PR,JeuG0[1],PixJeuG0[1],LgG0-2,Inverse,TpJeu_G0,1);
   SeekProcheMat(PR,JeuG2,PixJeuG2,LgG2,Inverse,TpJeu_G2,0);
   SeekProcheMat(PR,JeuG2B,PixJeuG2,LgG2B,Inverse,TpJeu_G2B,0);
  End;
End;

{ Recherche si un dessin des jeux standard est identique }

Procedure FindProcheDRCSMixte( var pr : ProcheResult );
Begin

 If CanOptG1 Then
  Begin
   If CanUseG1 Then
    Begin
     SeekProcheMat(PR,JeuG1,PixJeuG1,LgG1,Graphik,TpJeu_G1,0);
     If CanUseG1D Then SeekProcheMat(PR,JeuG1D,PixJeuG1D,LgG1,Graphik+Disjoint,TpJeu_G1D,0);
    End;
  End;

 If CanOptG0G2 And CanUseG0G2 Then FindProcheG0G2(PR);
End;



Function FindProcheSol : Boolean;
Var pr : ProcheResult;
    svOPP : Boolean;
Begin
 pr.CodeZ  := 32;
 pr.AttZ   := 0;
 pr.TpJeu  := TpJeu_G0;
 pr.PixZ   := 0;
 pr.BScore := 0;

 svOPP := OptProchePoussee;  { sauve }
 OptProchePoussee := FALSE;  { desactive momentannment }

 { peut importe les options dans le cas de $20 et $7F }
 SeekProcheMat(pr,Mat20,Pix20,1,0,TpJeu_20,0);
 SeekProcheMat(pr,Mat7F,Pix7F,1,0,TpJeu_7F,0);

 OptProchePoussee := svOPP Or
                     (OptProcheRapide And ((pr.TpJeu=TpJeu_20) Or (pr.TpJeu=TpJeu_7F)));

 If OptProcheDRCS Then FindProcheDRCS(pr);

 If OptMixte And OptProcheMixte Then FindProcheDRCSMixte(pr);

 If (pr.BScore>=PErr) Or NeedProche Then
  Begin { trouv ! }
   CodeZ   := pr.CodeZ;
   AttZ    := pr.AttZ;
   JeuZ    := pr.TpJeu;
   PixZ    := pr.PixZ;
   FindProcheSol := TRUE;
  End
 Else FindProcheSol := FALSE;

 OptProchePoussee := svOPP;
End;



Function NewDRCS : Boolean;
Var g, i, j : Byte;
    m : PMinMatrice;
Begin
 For g := 0 To 1 Do
  Begin
   i := TabG[g].Read;
   If i<TabG[g].Nb Then
    Begin
     Inc(i);
     TabG[g].Read := i;

     Dec(NbFreeDRCS);
     CodeZ    := i;
     PixZ     := 80;
     If g=0 Then
      Begin
       (*
       If ( (VD.Wait.Nb>0) And (VD.Wait.CurAtt And Inverse<>0) And
            (Mat[9] And 3<>0) ) Or
          ( (Mat[9]=0) And (Mat[8]=0) And (Mat[7] And 15=0) ) Then
        Begin
         AttZ := DRCS+Inverse;
         Pix := 80-Pix;
         For j := 0 To 9 Do Mat[j] := Mat[j] Xor 255;
        End
       Else *) AttZ := DRCS;
       JeuZ := TpJeu_DRCS0;
      End
     Else
      Begin
       AttZ := Graphik+DRCS;
       JeuZ := TpJeu_DRCS1;
      End;
     NewZ := TRUE;

     TabG[g].TabPix[i-1] := Pix;

     m := @RamDRCS^[g,i-1];

     For i := 0 To 9 Do m^[i] := Mat[i];

     NewDRCS := TRUE;
     Exit;
    End;
  End;
 NewDRCS := FALSE;  { y'en a plus !!! }
End;


Function DefineCodeDRCS : Boolean;
Begin
 If (Pix<>0) And (Pix<>80) Then
  If OptDRCS And FindBestDRCS Then DefineCodeDRCS := TRUE
  Else
   If OptMixte And FindBestDRCSMixte Then DefineCodeDRCS := TRUE
   Else
    If OptProche And FindProcheSol Then DefineCodeDRCS := TRUE
    Else DefineCodeDRCS := NewDRCS
 Else
  Begin
   If Pix=0 Then
    Begin
     CodeZ := 0;
     JeuZ  := TpJeu_20;
     AttZ  := 0;
     PixZ  := 80;
    End
   Else
    Begin
     CodeZ := 95;
     JeuZ  := TpJeu_7F;
     AttZ  := 0;
     PixZ  := 80;
    End;
   DefineCodeDRCS := TRUE;
  End;
End;


{ Traite et reduit en 64 niveaux de gris ! }

Procedure TraiteLV( Var lv : LineVideo );
Var i : Word;
    a : Longint;
    b : Longint;
Begin
 For i := 0 To dLg-1 Do
  Begin
   a := lv[i];

   { fentre de lumire }

   a := ((a-Longint(gBLo))*255) Div gBLarge;

   If a<0 Then a := 0
   Else
    If a>255 Then a := 255;

   { distorsion }

   b := 16384-(((a*a)+16129-254*a));

   b := (b*255*Longint(gLux)) Div (100*16384);

   Inc(a,b);

   if a<0 then a := 0
   else
     if a>255 then a := 255;

   lv[i] := a Shr 2;   { rduire ! }
  End;
End;


Procedure XLines2BW( First : Boolean );
Type IntRec = Record Lo, Hi : ShortInt; End;
Var i   : Byte;
    Hi  : PLineVideo;
    Lo  : PLineVideo;
    x   : Word;
    Err : ShortInt;
    z   : Integer;
    e   : Integer;
Begin
 If First Then
  Begin { le premier passage dlv^[1] devrat etre trait ici }
   Hi := dlv[1];
   For x := 0 To dLg-1 Do
    Begin
     Err := ShortInt(Hi^[x]);
     If Err>BWPiv Then Dec(Err,63);

     If x<dLg-1 Then
      Begin
       z := 7*BWProp*Err;
       Inc(ShortInt(Hi^[x+1]),IntRec(z).Hi);
      End;
    End;
  End;

 { noir & blanc }

 For i := 1 To RDY Do
  Begin
   Hi := dlv[i];
   Lo := dlv[i+1];

   For x := 0 To dLg-1 Do
    Begin
     Err := ShortInt(Hi^[x]);
     If Err<=BWPiv Then Hi^[x] := 0
     Else
      Begin
       Hi^[x] := 1;
       Dec(Err,63);
      End;

     e := BWProp*Err;

     If x<dLg-1 Then
      Begin
       z := 7*e;
       Inc(ShortInt(Hi^[x+1]),IntRec(z).Hi);

       z := e;
       Inc(ShortInt(Lo^[x+1]),IntRec(z).Hi);

      End;

     z := 5*e;
     Inc(ShortInt(Lo^[x]),IntRec(z).Hi);

     If x>0 Then
      Begin
       z := 3*e;
       Inc(ShortInt(Lo^[x-1]),IntRec(z).Hi);
      End;

    End;
  End;

End;


Procedure LoadXLines;
Var i   : Byte;
    t   : PLineVideo;
Begin
 If gLine=0 Then { c'est le debut }
  Begin
   i := 1;
  End
 Else
  Begin
   t := dlv[1];
   dlv[1] := dlv[RDY+1];
   dlv[RDY+1] := t;
   i := 2;
  End;

 While (i<=RDY+1) Do
  Begin
   If TailleProp Then
    If (i<=3) Or (i=11) Then ScaleReadLV(rcv1)
    Else
     If i<=6 Then ScaleReadLV(rcv2)
     Else ScaleReadLV(rcv3)
   Else ScaleReadLV(rcv1);

   ScaleLV(gResult^,dlv[i]^,rch);

   TraiteLV(dlv[i]^);
   Inc(i);
  End;

End;



Procedure DRCS_FlushWait;
Var s : String;
Begin
 FlushTrans(VD,s);
 EnvoiCom(s);
End;


Procedure EnvoiDRCSCom( Var s : String );
Begin
 If (ModeTele=MT_Pendant) And (ParamTele<0) Then Stock.Write(s)
 Else EnvoiCom(s);
End;


Procedure DRCS_CodeToMini( y : Byte );
Var c   : Byte;
    Att : Word;
    s   : String;
    z   : Word;
Begin

 If (JeuZ=TpJeu_20) Or (JeuZ=TpJeu_7F) Then
  Begin
   If VD.Wait.Nb>0 Then
    Begin
     If VD.Wait.CurAtt And Graphik=0 Then AttZ := AttZ And Not(Graphik)
     Else AttZ := AttZ Or Graphik;

     If (AttZ And Inverse)<>(VD.Wait.CurAtt And Inverse) Then
      Begin
       If JeuZ=TpJeu_20 Then
        Begin
         If Not(OptWithVide And (CFond=0) And
                ((AttZ And Graphik<>0) Or (AttZ And Inverse=0))) Then
          Begin
           JeuZ := TpJeu_7F;
           AttZ := AttZ Xor Inverse;
          End;
        End
       Else
        Begin
         JeuZ := TpJeu_20;
         AttZ := AttZ Xor Inverse;
        End;
      End;
    End;
  End;

 Att := AttZ Or (CTrait Or (CFond Shl 3) Or (G0Taille Shl 6) Or Stable);

 If OptWithVide And (JeuZ=TpJeu_20) And (CFond=0) And
    ((AttZ And Graphik<>0) Or (AttZ And Inverse=0)) Then c := 0
 Else
  Begin
   Case JeuZ Of
    TpJeu_G2    : Begin
                   c := Byte(TabSS2[CodeZ-1]);
                   Inc(NbG012);
                  End;
    TpJeu_G2B   : Begin
                   c := Byte(TabAccent[CodeZ]);
                   Inc(NbG012);
                  End;
    TpJeu_20    : c := $20;
    TpJeu_7F    : c := $7F;
    TpJeu_DRCS0 : c := TabG[0].First+CodeZ+32;
    TpJeu_DRCS1 : c := TabG[1].First+CodeZ+32;
    TpJeu_Nil   : Begin
                   c := Byte('?');
                   Att := Att And Not(Inverse+DRCS);
                   Inc(NbG012);
                  End;
   Else
    Begin
     c := CodeZ+31;
     Inc(NbG012);
    End;
   End;
  End;

 Inc(PixOk,PixZ);

 TransCode(VD,mX+col*MulmLg,y,Char(c),Att,s);
 EnvoiDRCSCom(s);
End;



Procedure AfficheDRCS( y : Byte );
Var s : String[32];
    g : Byte;
Begin

 If (nCom>0) And (AttZ And DRCS<>0) And NewZ And (ModeTele<>MT_Pendant) Then
  Begin
   If AttZ And Graphik<>0 Then
    Begin
     s := TeleG1;
     g := 1;
    End
   Else
    Begin
     s := TeleG0;
     g := 0;
    End;
   s := s+#$1F+#$23+Char(CodeZ+32)+
          #$30+CodeMatrice(RamDRCS^[g,CodeZ-1-TabG[g].First])+#$1F'ZZ';
   WriteCom(s);
  End;

 DRCS_CodeToMini( y );
End;



Procedure FlushTeleGX;
Var More : RamFile;
    s    : String;
    r    : Word;
Begin
 More.Init;

 WriteTeleGX(More);

 More.ResetGet;

 Repeat
  More.Read(s[1],sizeof(s)-1,r);
  s[0] := Char(r);
  EnvoiCom(s);
 Until r=0;

 More.Done;
End;


Procedure FlushBackTeleGX;
Var s    : String;
    r    : Word;
Begin
 FlushTeleGX;

 Stock.ResetGet;

 Repeat
  Stock.Read(s[1],sizeof(s)-1,r);
  s[0] := Char(r);
  EnvoiCom(s);
 Until r=0;

 FlushTrans(VD,s);
 EnvoiCom(s);

 Stock.Done;
 Stock.Init;
End;


Function HautBas_DRCS : Boolean;
Var s   : String;
    lig : Word;
    z   : Word;
    yr  : Byte;
    f   : Boolean;
    l   : Byte;
    i   : Byte;
    h   : Byte;
    tx  : Longint;
Begin
 ClrJeuxDRCS;

 If (ModeTele=MT_Pendant) Then
  Begin
   If (ParamTele<0) Then Stock.Init;
  End
 Else
  If ModeTele=MT_Debut Then
   Begin
    If M0Str<>'' Then
     Begin
      IbmVdt(M0Str,s);
      WriteCom(#31'@A'+s+#24+#10);
     End;
   End;

 h := 0;
 z := 0;
 Write(' Ligne n');
 For lig := mY To mY+(mNb-1) Do
  Begin
   s := ValStr(mY+z,0)+'  ('+ValStr((lig-mY)+1,0)+'/'+ValStr(mNb,0)+')  (G0:'+
        ValStr(TabG[0].Read,0)+'/'+ValStr(TabG[0].Nb,0)+',G1:'+
        ValStr(TabG[1].Read,0)+'/'+ValStr(TabG[1].Nb,0);
   If NbG012>0 Then s := s+',G?:'+ValStr(NbG012,0);
   If PixOk<PixTotal Then s := s+',E:'+ValStr((1000*(PixTotal-PixOk))Div PixTotal,0)+'%.';
   s := s+')   ';
   l := Length(s);
   Write(s);

   If mY+z<=ScreenHigh-1 Then yr := mY+z
   Else
    Begin
     yr := ScreenHigh-1;

     If ModeScroll Then
      If VD.NextLn=0 Then
       Begin
        If MulmNb=2 Then
         Begin
          TransCodeScrollUp(VD,s);
          EnvoiDRCSCom(s);
         End;
        TransCodeScrollUp(VD,s);
        EnvoiDRCSCom(s);
       End
      Else
       Begin
        FlushTrans(VD,s);
        EnvoiDRCSCom(s);
        If VD.UseCAN Then
         Begin
          If MulmNb=2 Then
           Begin
            TransCodeScrollUp(VD,s);
            EnvoiDRCSCom(s);
           End;
          TransCodeScrollUp(VD,s);
          EnvoiDRCSCom(s);
         End;
       End;

    End;

   If ModeTele=MT_Pendant Then
    If ParamTele>0 Then
     Begin
      If h>=ParamTele Then
       Begin
        FlushTeleGX;
        h := 0;
       End;
     End
    Else
     Begin
      If h>=Abs(ParamTele) Then
       Begin
        FlushBackTeleGX;
        h := 0;
       End;
     End;


   f := gLine=0;  { TRUE=> c'est le debut }
   LoadXLines;
   XLines2BW(f);

   tx := 0;
   For col := 0 To mLg-1 Do
    Begin
     If tx<=GetC18 Then
      Begin
       Write(#8,Roto[ScaleRo]);
       Inc(ScaleRo);
       If ScaleRo>=4 Then ScaleRo := 0;
       tx := GetC18+(18 Div 4);
      End;

     ChargeMat;
     If Not(DefineCodeDRCS) Then
      Begin
       HautBas_DRCS := FALSE;
       Exit;
      End;
     AfficheDRCS(yr);
    End;

   Inc(h);

   Write(' '#8);

   For i := 1 To l Do Write(#8);

   Inc(z,MulmNb);
  End;

 Write(#8#8#8#8#8#8#8#8#8);
 HautBas_DRCS := TRUE;
End;


Var SaveExitDRCS : Pointer;

Procedure _RestoreDRCS;
Begin
 WriteCom(#$1F'ZZ');
 WriteCom(ActG0Std);
 WriteCom(ActG1Std);
End;

Procedure RestoreDRCS; Far;
Begin
 ExitProc := SaveExitDRCS;
 If nCom>0 Then Mntl.TransmitClear;
 _RestoreDRCS;
 WaitOutEmpty;
End;


Function Transforme : Boolean;
Var Ram  : PVDispRam;
    Ram2 : PVDispRamDRCS;
    Src  : PVDispRamDRCS;
begin

 FRam.Init;


 If Byte(DefaultCfg.CSI)=255 Then
  Begin
   If ConvMode=CM_DRCS Then DefaultCfg.CSI := TRUE
   Else DefaultCfg.CSI := FALSE;
  End;
 If Byte(OptWithVide)=255 Then OptWithVide := VideEcran;
 DefaultCfg.OptNILDRCS := OptMixte;

 { Initialise VDisp ... }

 FillChar(VD,SizeOf(VD),0);

 New(Ram);
 ClearRam(Ram);

 New(Ram2);
 ClearRamDRCS(Ram2);

 { RamDRCS: sert aussi bien  VD qu' PCX2VDT }

 If ConvMode=CM_DRCS Then
  Begin
   New(RamDRCS);
   ClearRamDRCS(RamDRCS);

   If (ModeTele=MT_Pendant) And (ParamTele=0) Then Src := RamDRCS
   Else Src := NIL;

   InitVD(VD,Ram,Ram2,Src);
   InitJeuG1;
   InitPixJeux;
  End
 Else
  Begin
   InitVD(VD,Ram,Ram2,NIL);
  End;

 VD.Cfg     := DefaultCfg;



  write('Conversion ...');

  VD.Cur.X   := 0;
  VD.Cur.Y   := 0;
  VD.Cur.Att := Trait+Stable;

  if VideLZ then
   Begin
    EnvoiCom(#31'@A'#24);
    VD.Cur.Rdy := TRUE;
   End;

  if VideEcran then
   Begin
    EnvoiCom(#12);
    VD.Cur.Y := 1;
    VD.Cur.Rdy := TRUE;
   End;

  if (mY+mNb*MulmNb>25) Then
   Begin
    VD.Cfg.Scroll    := TRUE;
    VD.Cfg.DebCursor := FALSE;
    ModeScroll       := TRUE;
    If Scrolling then
     begin
       if MModem then FRam.Write(#27#$3A'f'+char(4)); { ecrit en ram seulement }
       EnvoiCom(#27#$3A#$69#$43); { mode rouleau }
     end
    Else WriteCom(#27#$3A#$69#$43); { mode rouleau en local }
   End
  Else ModeScroll := FALSE;

  If ConvMode=CM_DRCS Then
   Begin
    SaveExitDRCS := ExitProc;
    ExitProc := @RestoreDRCS;
    If Not(HautBas_DRCS) Then
     Begin
      RestoreDRCS;

      ClrLine;

      Writeln(' Pas assez de caractres DRCS ');
      Transforme := FALSE;
      Exit;
     End;
   End
  Else HautBas;

  if (mY+mNb*MulmNb>25) Then
   If Scrolling then
    begin
      { on envoi la fin de scroll avant Flush ... }

      if MModem then FRam.Write(#27#$3A'f'+char(4)); { ecrit en ram seulement }
      EnvoiCom(#27#$3A#$6A#$43); { mode page }
    end
   Else WriteCom(#27#$3A#$6A#$43); { mode page (local) }

  If ConvMode=CM_DRCS Then
   Begin
    If ModeTele=MT_Pendant Then
     If ParamTele>0 Then
      Begin
       FlushTeleGX;
      End
     Else
      If (ParamTele<0) Then
       Begin
        FlushBackTeleGX;
        Stock.Done;
       End;

    DRCS_FlushWait;
    ExitProc := SaveExitDRCS;
    _RestoreDRCS;

    If ModeTele=MT_Debut Then
     If (M0Str<>'') And (mY>0) Then
      Begin
       WriteCom(#31'@A'+#24+#10);
      End;
   End
  Else FlushWait;

  ClrLine;

  Transforme := TRUE;
end;


procedure ErreurDest( io : word );
begin
  writeln('Erreur n',io,' sur le fichier destination');
end;

procedure Sauve;
Type MotifRec = Record
       m   : Char;
       top : Byte;
      End;

Const NbMotif = 6;
      Motif : Array[1..NbMotif] Of MotifRec = (
       ( m:' '; top:0   ),
       ( m:''; top:3   ),
       ( m:''; top:11  ),
       ( m:''; top:19  ),
       ( m:''; top:29  ),
       ( m:''; top:100 )
       );

var r   : word;
    lg  : word;
    i   : Byte;
    p   : Byte;
    j   : Byte;
    fvdt: File;
    io  : Word;
    s   : String;
begin
  If Not(Test) Then
   Begin
    Assign(fvdt,VDTName+DefaultExt);
    rewrite(fvdt,1);
    io := ioresult;
    If io<>0 Then
     Begin
      Writeln('Sauvegarde impossible');
      Exit;
     End;
   End;

  ResetTrans(VD,s);
  FRam.Write(s);

  lg := FRam.Size;
  write(Lg,' codes (',Lg/GetCPSreel:0:1,'s) [');
  For i := 0 To 7 Do
   Begin
    p := (Longint(NbPixels[i])*100) Div (dLg*mNb*3);
    j := 1;
    While j<=NbMotif Do
     If p<=Motif[j].top Then
      Begin
       Write(Motif[j].m);
       j := NbMotif+1;
      End
     Else Inc(j);
   End;

  Write('] dans ''',VDTName+DefaultExt,'''');

  If Test Then Writeln('  TEST ')
  Else
   Begin
    Writeln;

    FRam.ResetGet;

    repeat
      FRam.Read(Mark.buf,sizeof(Mark.buf),r);
      if r>0 then BlockWrite(fvdt,Mark.buf,r,r);
    until r=0;

    close(fvdt);
   End;
end;


Procedure SauveDRCS;
var r   : word;
    lg  : word;
    i   : Byte;
    p   : Byte;
    j   : Byte;
    fvdt: File;
    io  : Word;
    More: RamFile;   { telechargement (ou autre info) }
    s   : String;
Begin

 More.Init;

 ResetTrans(VD,s);
 FRam.Write(s);

 Case ModeTele Of
  MT_Debut   :
   Begin
    If M0Str<>'' Then
     Begin
      IbmVdt(M0Str,s);
      More.Write(#31'@A'+s+#24+#10);
     End;

    WriteTeleGX(More);

    If (M0Str<>'') And (mY>0) And Not(VideLZ) Then
     Begin
      More.Write(#31'@A'+#24+#10);
     End;
   End;

  MT_Pendant :
   Begin
    If (ParamTele>0) And VideDRCS Then ClrTeleGX(More);  { vider le DRCS avant l'affichage }
   End;

  MT_Fin :
   Begin { ajouter le tlchargement  la fin }

    WriteTeleGX(FRam);

    If VideDRCS Then ClrTeleGX(More);  { vider le DRCS avant l'affichage }

   End;

  MT_Disjoint :
   Begin
    WriteTeleGX(More);
   End;

 End;

 lg := FRam.Size+More.Size;

 Write(Lg,' codes (',Lg/GetCPSReel:0:1,'s) (G0:',TabG[0].Read,',G1:',TabG[1].Read);
 If NbG012>0 Then Write(',G?:',NbG012);
 If PixOk<PixTotal Then Write(',E:',((1000*(PixTotal-PixOk))Div PixTotal),'%.');
 Write(')');
 Write(' dans ''',VDTName+DefaultExt,'''');
 If ModeTele=MT_Disjoint Then Write('(DRCS  part)');

 If Test Then Writeln('  TEST ')
 Else
  Begin
   Writeln;

   Assign(fvdt,VDTName+DefaultExt);
   rewrite(fvdt,1);
   io := ioresult;
   If io<>0 Then
    Begin
     Writeln('Sauvegarde impossible');
     Exit;
    End;

   { si info a ajouter au debut: }

   If ModeTele<>MT_Disjoint Then
    Begin
     More.ResetGet;

     repeat
      More.Read(Mark.buf,sizeof(Mark.buf),r);
      if r>0 then BlockWrite(fvdt,Mark.buf,r,r);
     until r=0;
    End;


   FRam.ResetGet;

   repeat
     FRam.Read(Mark.buf,sizeof(Mark.buf),r);
     if r>0 then BlockWrite(fvdt,Mark.buf,r,r);
   until r=0;

   close(fvdt);

   If ModeTele=MT_Disjoint Then
    Begin
     Assign(fvdt,VDTName+'.DRC');
     rewrite(fvdt,1);
     io := ioresult;
     If io<>0 Then
      Begin
       Writeln('Sauvegarde du DRCS impossible');
       Exit;
      End;

     { si info a ajouter au debut: }

     More.ResetGet;

     repeat
      More.Read(Mark.buf,sizeof(Mark.buf),r);
      if r>0 then BlockWrite(fvdt,Mark.buf,r,r);
     until r=0;

     close(fvdt);
    End;
  End;


 More.Done;

End;


Function VerifyFileDest : Boolean;
Var fvdt : File;
    io   : Word;
Begin
 If Test Then VerifyFileDest := TRUE
 Else
  Begin
   Assign(fvdt,VDTName+DefaultExt);
   reset(fvdt,1);
   io := IoResult;
   if (io=0) or (io=2) then
    Begin
     if io=0 then close(fvdt);
     VerifyFileDest := TRUE
    End
   Else
    Begin
     Writeln('Fichier de sauvegarde invalide');
     VerifyFileDest := FALSE;
    End;
  End;
End;


Procedure EnvoiMinitel;
Var f    : File;
    Name : String;
    sz   : Longint;
    r    : Word;
    lu   : Longint;
    ro   : Byte;
    tx   : Longint;
Begin
 If nCom=0 Then
  Begin
   Writeln('Utilis l''option /C=... pour dfinir une voie de communication.')
  End
 Else
  Begin
   DebutCom;

   Name := VDTName+DefaultExt;
   Assign(f,Name);
   Reset(f,1);
   If IoResult=0 Then
    Begin
     sz := FileSize(f);
     lu := 0;
     ro := 0;
     Writeln('Envoi de ''',Name,''' (',sz,' octets)');
     Write('Codes envoys ... ');
     While Not(Eof(f)) Do
      Begin
       BlockRead(f,Name[1],SizeOf(Name)-1,r);
       Name[0] := Char(r);
       Inc(lu,r);
       WriteCom(Name);

       tx := 0;

       Write(((lu-r)*100) Div sz:3,'%   ');

       Repeat
        Begin
         r := Mntl.TransmitCount;
         If tx<=GetC18 Then
          Begin
           Inc(ro);
           If ro>=4 Then ro := 0;
           tx := GetC18+(18 Div 2);
           Write(#8+Roto[ro]);
          End;
        End;
       Until r<=10;

       Write(' '#8#8#8#8#8#8#8#8);
      End;
     Close(f);
     ClrLine;
     Writeln('Ok.');
    End
   Else Writeln('Impossible d''ouvrir ''',Name,'''');

   FinCom;
  End;
End;


{ PCX => PCX }


Var fpcx     : File;
    MarkDest : MarkerRec;

Function CreatPCX : Boolean;
Var h : PCXHeadRec;
Begin
 Assign(fpcx,'PCX2VDT.TMP');
 ReWrite(fpcx,1);
 If IoResult=0 Then
  Begin
   FillChar(MarkDest,SizeOf(MarkDest),0);
   FillChar(h,SizeOf(h),0);
   BlockWrite(fpcx,h,SizeOf(h));   { creer le header (vide) }
   CreatPCX := TRUE;
   Exit;
  End
 Else Writeln('Impossible de crer un fichier temporaire!');
 CreatPCX := FALSE;
End;


Function ClosePCX : Boolean;

Var h : PCXHeadRec;
    f : File;
    e : Word;
    p : Pal256;
    i : Byte;
    g : Byte;
    sz : Longint;
    Lig : String;
Begin
 FillChar(p,SizeOf(p),0);

 For i := 0 To 63 Do
  Begin
   g := i*4;
   p[i].Red   := g;
   p[i].Green := g;
   p[i].Blue  := g;
  End;

 { ecrire palette a la fin }
 Seek(fpcx,FileSize(fpcx));
 e := $0C;
 BlockWrite(fpcx,Byte(e),1);
 BlockWrite(fpcx,p,SizeOf(p));

 FillChar(h,SizeOf(h),0);
 h.Marque  := 10;
 h.Version := 5;
 h.Codage  := 1;
 h.BPX     := 8;
 h.XG      := 0;
 h.YH      := 0;
 h.XD      := dLg-1;
 h.YB      := dNb-1;
 h.HRes    := 0;
 h.VRes    := 0;
 h.Palette := Palette16;
 h.NbPlans := 1;
 h.BPL     := dLg;

 Seek(fpcx,0);
 BlockWrite(fpcx,h,SizeOf(h));

 sz := FileSize(fpcx);

 Close(fpcx);
 e := IoResult;


 Lig := GetMainName+'.PCX';


 Assign(f,Lig);
 Erase(f);
 e := IoResult;

 Rename(fpcx,Lig);
 If IoResult<>0 Then
  Begin
   Writeln('Impossible de sauver! (voir PCX2VDT.TMP)');
   ClosePCX := FALSE;
  End
 Else
  Begin
   Writeln('Fichier PCX cr: ',Lig,'  (',sz Div 1024,' Ko)');
   ClosePCX := TRUE;
  End;
End;



Procedure FlushBufDisk;
Var r : Word;
Begin
 If MarkDest.LgBuf>0 Then
  Begin
   BlockWrite(fpcx,MarkDest.Buf,MarkDest.LgBuf,r);
   MarkDest.LgBuf := 0;
  End;
End;


Procedure WriteToDisk( b : Byte ); Assembler;
Asm
    MOV  BX, [MarkDest.LgBuf]
    MOV  AL, [b]
    MOV  [BYTE PTR MarkDest.Buf+BX], AL
    INC  [MarkDest.LgBuf]
    CMP  [MarkDest.LgBuf], TYPE MarkDest.Buf
    JB   @FIN
    CALL FlushBufDisk
@FIN:
End;


Procedure FlushRep;
Var i : Byte;
Begin
 If MarkDest.NbRep>0 Then
  Begin
   If (MarkDest.CCode And (64+128))=(64+128) Then
    Begin
     WriteToDisk(64+128+MarkDest.NbRep);
     WriteToDisk(MarkDest.CCode);
    End
   Else
    If (MarkDest.NbRep>2) Then
     Begin { coder une repetition }
      WriteToDisk(64+128+MarkDest.NbRep);
      WriteToDisk(MarkDest.CCode);
     End
    Else
     Begin
      For i := 1 To MarkDest.NbRep Do WriteToDisk(MarkDest.CCode);
     End;
   MarkDest.NbRep := 0;
  End;
End;



Procedure WriteByte( o : Byte ); Assembler;
Asm
    MOV  AH, [o]
    MOV  AL, [MarkDest.NbRep]
    OR   AL, AL
    JZ   @ZERO
    CMP  [MarkDest.CCode], AH
    JE   @ZERO_2
    CALL FlushRep
    MOV  AH, [o]
    MOV  AL, [MarkDest.NbRep]
@ZERO:
    MOV  [MarkDest.CCode], AH
@ZERO_2:
    INC  AL
    MOV  [MarkDest.NbRep], AL
    CMP  AL, 63
    JB   @FIN
    CALL FlushRep
@FIN:
End;



Procedure WriteToPCX;
Var i : Byte;
    x : Word;
    z : PLineVideo;
    m : Byte;
Begin
 For i := 1 To RDY Do
  Begin
   z := dlv[i];
   For x := 0 To dLg-1 Do
    Begin
     WriteByte(z^[x] And 63);
    End;
   FlushRep;
  End;
End;


Function SauvePCX : Boolean;
Var s   : String;
    l   : Byte;
    i   : Byte;
    lig : Word;
Begin
 If CreatPCX Then
  Begin

   Write('Traitement ... Ligne n');
   For lig := mY To mY+(mNb-1) Do
    Begin
     s := ValStr((lig-mY)+1,0)+'/'+ValStr(mNb,0)+'  ('+ValStr(gLine+1,0)+'/'+
          ValStr(gNb,0)+')  ';
     l := Length(s);
     Write(s);

     LoadXLines;
     WriteToPCX;

     For i := 1 To l Do Write(#8);

    End;

   ClrLine;

   FlushRep;
   FlushBufDisk;

   SauvePCX := ClosePCX;

  End
 Else SauvePCX := FALSE;
End;


{ PCX => JPEG }

Function CreatJPG : Boolean;
Var s : String;
    cmd : String;
    i : Word;
    yop : Boolean;
    t : String[10];
Begin
 CreatJPG := FALSE;
 s := '';
 yop := FALSE;
 For i := 1 To Length(JPEGExecParam) Do
  Begin
   If yop Then
    Begin
     Case UpCase(JPEGExecParam[i]) Of
      'Q' :
        Begin
         str(JPEGQua,t);
         s := s+t;
        End;
      'S' :
        Begin
         s := s+GetMainName+'.PCX';
        End;
      'D' :
        Begin
         s := s+GetMainName+'.JPG';
        End;
     End;
     { ignore si erreur de parametre }
     yop := FALSE;
    End
   Else
    If JPEGExecParam[i]='~' Then yop := TRUE
    Else
     Begin
      yop := FALSE;
      Inc(s[0]); s[length(s)] := JPEGExecParam[i];
     End;
  End;
 If (JPEGExec<>'') Then
  Begin
   Writeln(JPEGExec,' ',s);
   cmd := GetEnv('COMSPEC');
   if cmd='' then cmd := '\COMMAND.COM';
   SwapVectors;
   Exec(cmd,'/C '+JPEGExec+' '+s);
   SwapVectors;
   If DosError<>0 Then
    Begin
     Write('Erreur DOS n ',DosError);
     Case DosError Of
      2 : Writeln(' : fichier non trouv');
      8 : Writeln(' : pas assez de mmoire');
     Else Writeln;
     End;
    End
   Else
    Begin
     If DosExitCode<>0 Then Writeln('Ok. (',DosExitCode,')');
     CreatJPG := TRUE;
    End;
  End
 Else Writeln('Rien  xcuter !');
End;

(*
Procedure WriteJPGVDT( Var f : File; s : String; Var Count : Longint );
Begin
 BlockWrite(f,s[1],Length(s));
 WriteCom(s);
 Inc(Count,Length(s));
End;
*)

type AigJPG = ( AJ_NUL, AJ_FF, AJ_SEG_HI, AJ_SEG_LOW, AJ_RUN, AJ_RUN_STDBY );

     JPGFiltre = Record
       Aig  : AigJPG;
{       _Aig : AigJPG; } { sauvegarde }
       Mark : Byte;
       Len  : Word;
       iRead: Word;
       res  : Byte;
       sv   : Boolean;          { indique s'il faut sauver }
       cpok : Boolean;
      End;

Function AnaJPEG( Var fl : JPGFiltre; b : Byte ) : Boolean;
Var Good : Boolean;
label running;
Begin
 Good := FALSE;

 Case fl.Aig Of
  AJ_NUL : If b=$FF Then fl.Aig := AJ_FF
           Else; { Erreur! }
  AJ_FF, AJ_RUN_STDBY :
   If (fl.Aig=AJ_RUN_STDBY) And (b=$00) Then
    Begin
     fl.Aig := AJ_RUN;
     b := $FF;
     goto running;
    End
   Else
    If b In [$D0..$DA,$01,$00,$FF] Then
     Begin
      fl.Aig := AJ_RUN;
      fl.Mark := b;
      fl.Len := $FFFF;
      fl.iRead := 0;
     End
    Else
     Begin
      fl.Aig := AJ_SEG_HI;
      fl.Mark := b;
      fl.Len := $0000;
     End;
  AJ_SEG_HI :
   Begin
    fl.Aig := AJ_SEG_LOW;
    fl.Len := b*256;
   End;
  AJ_SEG_LOW :
   Begin
    fl.Aig := AJ_RUN;
    fl.Len := (fl.Len+b)-2;
    fl.iRead := 0;
   End;
  AJ_RUN :
   Begin
    If b=$FF Then fl.Aig := AJ_RUN_STDBY
    Else
     Begin
running:
      If fl.iRead<fl.len Then
       Begin
        fl.res := b;
        Good := TRUE;
        Inc(fl.iRead);
       End;
     End;
   End;
 End;

 AnaJPEG := Good;
End;


Procedure EnvoiJPEGCom( Texte : String; Var how : Longint );
Begin
 EnvoiCom(#$FF#$FE+char((length(texte)+2)div 256)+char(length(texte)+2)+texte);
 Inc(how,2+2+length(texte));
End;


Procedure EnvoiJPEG( Var fl : JPGFiltre; Var s : String; Var how : LongInt );
Var i : Byte;
Begin
 For i := 1 To Length(s) Do
  Begin
   If AnaJPEG(fl,Byte(s[i])) Then
    Begin { il faut sauver ca! }
     If fl.sv Then
      if fl.res=$FF then
       Begin   { est-ce possible ??? }
        EnvoiCom(#$FF#$00);
        inc(how,2);
       End
      else
       Begin
        EnvoiCom(char(fl.res));
        inc(how);
       End;
    End
   Else
    If fl.Aig=AJ_RUN Then
     Begin
      If Not(JPEGFiltre) Or (fl.Mark In [$D8,$DB,$C0,$DA,$D9]) Then
       Begin
        fl.sv := TRUE;

        EnvoiCom(#$FF+Char(fl.Mark));
        Inc(how,2);

        If fl.len<>$FFFF Then
         Begin
          EnvoiCom(char((fl.len+2)div 256)+char(fl.len+2));
          Inc(how,2);
         End;

        If (fl.Mark=$D8) And Not(fl.cpok) Then
         Begin { dbut de la photo... on fait suivre part les commentaires }
          fl.cpok := TRUE;
          EnvoiJPEGCom('PCX2VDT 2.4 (C) T.Jaouen',how);
          If JPEGCP<>'' Then EnvoiJPEGCom(JPEGCP,how);
         End;
       End
      Else fl.sv := FALSE;
     End;
  End;
End;


Procedure CreatJPGVDT;
Var err : Word;
    size : LongInt;
    fdest : File;
    s : String;
    lu : LongInt;
    tx : LongInt;
    ro : Word;
    r : Word;
    how : Longint;
    fl : JPGFiltre;
Begin
 DebutCom;

 Assign(fpcx,GetMainName+'.JPG');
 Reset(fpcx,1);
 err := IoResult;
 If err=0 Then
  Begin
   size := FileSize(fpcx);
   Writeln('Traitement de '+GetMainName+'.JPG  (',size div 1024,' Ko)');

   FRam.Init;

   Write('Codes traits ... ');
   lu := 0;
   tx := 0;
   ro := 0;
   how := 0;
   If VideLZ Then
    Begin
     s := #31'@A'#24#10;
     EnvoiCom(s);
     Inc(how,Length(s));
    End;
   If VideEcran Then
    Begin
     s := #12;
     EnvoiCom(s);
     Inc(how,Length(s));
    End;
   If JPEGSitu Then
    Begin
     s := #31+char(64+mY)+char(64+mX);
     EnvoiCom(s);
     Inc(how,Length(s));
    End;

   fl.Aig := AJ_NUL;
   fl.cpok := FALSE;    { indique CoPyrigth non ecrit }

   While Not(Eof(fpcx)) Do
    Begin
     BlockRead(fpcx,s[1],SizeOf(s)-1,r);
     s[0] := Char(r);

     Inc(lu,r);

     EnvoiJPEG(fl,s,how);

     Write(((lu-r)*100) Div size:3,'%   ');

     If tx<=GetC18 Then
      Begin
       Inc(ro);
       If ro>=4 Then ro := 0;
       tx := GetC18+(18 Div 2);
       Write(#8+Roto[ro]);
      End;

     Write(' '#8#8#8#8#8#8#8#8);
    End;

   ClrLine;
   Write(how,' codes (',how/GetCPSReel:0:1,'s) dans ''',VDTName+DefaultExt,'''');

   Close(fpcx);

   If Test Then Writeln('  TEST ')
   Else
    Begin
     Assign(fdest,VDTName+DefaultExt);
     ReWrite(fdest,1);
     err := IoResult;
     If err=0 Then
      Begin
       Writeln;

       FRam.ResetGet;

       repeat
         FRam.Read(Mark.buf,sizeof(Mark.buf),r);
         if r>0 then BlockWrite(fdest,Mark.buf,r,r);
       until r=0;

       Close(fdest);
      End
     Else Writeln('Erreur disque n ',err);
    End;

   FRam.Done;

  End
 Else Writeln('Erreur disque n ',err);

 FinCom;
End;

Procedure ToJPEG;
Begin
 If mY=0 Then mY:=1;
 If mNb>=ScreenHigh Then mNb:=ScreenHigh-1;
 If (mY+mNb)>=ScreenHigh Then
  Begin
   mY := ScreenHigh-mNb;
  End;
 Case JPEGMode Of
  JPEGMODE_JPEG : If CreatJPG Then CreatJPGVDT;
  JPEGMODE_VDT : CreatJPGVDT;
 Else If SauvePCX And CreatJPG Then CreatJPGVDT;
 End;
End;

Procedure SaveOptions;
Var f : Text;
    o : POptRec;
    h : Word;
    Name : String;
    r : DirStr;
    n : NameStr;
    e : ExtStr;
    i : word;
Begin
 FSplit(VDTName,r,n,e);
 Name := n+'.CFG';
 Assign(f,Name);
 ReWrite(f);
 If IoResult<>0 Then
  Begin
   Writeln('Impossible de sauver les options!');
  End
 Else
  Begin
   Write('Sauvegarde des options ... ');
   o := FirstOpt;
   h := 0;
   While o<>NIL Do
    Begin
     If o^.Save Then
      Begin
       Writeln(f,o^.Opt);
       Inc(h);
      End;
     o := o^.Next;
    End;
   Writeln(f,PCXName);
   Close(f);
   Writeln(h,' option(s) dans ''',Name,'''');
  End;
End;


Procedure ListOptions;
Var o : POptRec;
    h : Word;
    t : Boolean;
Begin
 o := FirstOpt;
 h := 0;
 While o<>NIL Do
  Begin
   Inc(h);
   o := o^.Next;
  End;

 Writeln('Liste des options ... ',h,' option(s)');
 o := FirstOpt;
 While o<>NIL Do
  Begin
   Write(o^.Opt);
   If Not(o^.Save) Then
    Begin
     Write('    <== Option ignore par /CFG');
    End;
   Writeln;
   o := o^.Next;
  End;
 Writeln(PCXName,'    <== Nom du fichier PCX courant');
End;


Procedure Pause;
Begin
 Write('Appuyez une touche pour continuer ... ');
 Asm
 @RELIT:
     MOV  AH, 08h
     INT  21h
     OR   AL, AL
     JZ   @RELIT
 End;
 ClrLine;
End;


Procedure EndHelp;
Begin
 Writeln(#10#10#10#10);
 Writeln('Ŀ');
 Writeln('Le logiciel "PCX2VDT" Version 2.4 est un SHAREWARE.                         ');
 Writeln('Toutes utilisations commerciales du logiciel est interdite sans accord      ');
 Writeln('crit avec les ayants droits.                                               ');
 Writeln('Aprs une priode d''essai du logiciel de 30 jours, une participation de     ');
 Writeln('100 FF est souhaite. (chque  l''ordre de Thierry JAOUEN)                  ');
 Writeln('Les ayants droits ne peuvent pas tre tenus responsables de dommages directs');
 Writeln('ou indirects dcoulant de l''utilisation de ce logiciel.                     ');
 Writeln('Tous droits rservs.                         Copyright (c) 1991,93 T.JAOUEN');
 Writeln('Ĵ');
 Writeln('                         Monsieur Thierry JAOUEN                            ');
 Writeln('                       2, avenue Winston Churchill                          ');
 Writeln('                         94220  Charenton le pont  (FRANCE)                 ');
 Writeln('');
 Writeln(#10#10#10#10);
End;

Procedure IntroHelp;
Begin
 Writeln;
 Writeln('Convertisseur de toutes images PCX avec 2, 4, 16 ou 256 couleurs, en images');
 Writeln('minitels SEMI-GRAPHIQUE (2x3), D.R.C.S. (8x10) , ou JPEG/Photo (8x10x64).'#10);
(*
 Writeln('Convertisseur d''images PCX, en images Minitels Semi-Graphique, DRCS.');
*)
 Writeln('Usage: PCX2VDT [options] nom_pcx [nom_vdt] [options]'#10);
 Writeln('Les principales options:');
 Writeln('------------------------');
 Writeln(' /D   Conversion en DRCS (au lieu de Semi-Graphique)');
 Writeln(' /J   Conversion en JPEG/Photo ...');
 Writeln(' /L=   Traitement sur la lumire de l''image PCX');
 Writeln('       /L=Limite_Noir,Limite_Blanc,Contraste. Par dfaut: /L=0,100,0');
 Writeln(' /M=   Destination sur minitel. /M=Colonne,Ligne,Nombre_Colonne,Nombre_Ligne');
 Writeln('       Par dfaut: /M=0,1,40,24');
 Writeln(' /P=   Source de l''image PCX. /P=X,Y,Largeur,Hauteur');
 Writeln('       Par dfaut: /P=0,0,Largeur_Maximun,Hauteur_Maximun');
 Writeln;
 Writeln('Exemples:  C:\>PCX2VDT IMAGE1.PCX  (un fichier IMAGE1.VDT est cr)');
 Writeln('           C:\>PCX2VDT IMAGE1.PCX /L=,,70 /D+ /M=,,18,12');
 Writeln('             (un fichier IMAGE1.VDT avec des codes DRCS est cr)');
 Writeln;
 Pause;
 Writeln('Fonctions DOS lmentaires:');
 Writeln('---------------------------');
 Writeln(' [F1]    Rappelle caractre par caractre, la dernire saisie.');
 Writeln(' [F3]    Rappelle entirement la dernire saisie.');
 Writeln(' [Esc]   Abandonne la saisie en cours.');
 Writeln(' [Inser] Pour inserer des caractres dans la dernire saisie.');
 Writeln;
 Writeln('Utilisez l''option /CFG afin de sauvegarder toutes les options en cours.');
 Writeln('(sauvegarde toujours dans le rpertoire courant)');
 Writeln('/LST affiche toutes les options participant  la conversion.');
 Writeln;
 Writeln('Exemple:   C:\>PCX2VDT IMAGE1.PCX /L=,,70 /D+ /M=,,18,12 /CFG');
 Writeln('           (un fichier IMAGE1.CFG est cr ou modifi)');
 Writeln('           Ensuite C:\>PCX2VDT IMAGE1   suffit !');
End;

Procedure ShortHelp;
Begin
 Writeln;
 Writeln('Tapez PCX2VDT /? pour une aide plus complte...');
 IntroHelp;
 Writeln;
 Pause;
 EndHelp;
End;

Procedure CompleteHelp;
Begin
 IntroHelp;
 Pause;
 Writeln;
 Writeln('       Liste des options disponibles. LISEZ AUSSI LA DOCUMENTATION !');
 Writeln('       -------------------------------------------------------------');
 Writeln('                       -----( Options Gnrales )-----');
 Writeln('/C=   port COM,vitesse,IRQ,...        | /CSI Optimise avec squences CSI');
 Writeln('/DC  optimise par Dbordement Curseur| /EX=  EXtension fichier videotex');
 Writeln('/L=   noir,blanc,contraste            | /M=   colonne,ligne,largeur,hauteur');
 Writeln('/MM  code pour modem minitel         | /OR  Optimise les rptitions');
 Writeln('/ORC Optimise avec CANCEL            | /ORX Optim.rpt.en standard');
 Writeln('/OSG Optimisation Spciale Graphique | /OST Optimise Spciale Texte');
 Writeln('/OV  Optimise avec des Vides         | /P=   x,y,largeur,hauteur (pixels)');
 Writeln('/R   code pour cran Rouleau         | /RL=  vitesse ReLle d''affichage');
 Writeln('/SIL SILence sur la ligne            | /SV=  rpertoire de SauVegarde');
 Writeln('/T   Test: pas de sauvegarde         | /V   Vide le minitel (ligne 1  24)');
 Writeln('/V0  Vide la ligne 0                 | /7B   force com sur 7 bits');
 Writeln('/8B   force com sur 8 bits            | /XB   detection com sur 7 ou 8 bits');
 Writeln('/PAR= Parity  data Bits  Stop');
 Writeln;
 Writeln('                      -----( Semi-Graphisme /D- /J- )-----');
 Writeln('/OG  Optimise en alterant le Graphisme');
 Writeln;
 Pause;
 Writeln('                          -----( D.R.C.S. /D+ /J- )-----');
 Writeln('/BW=  algo.,limite,propag.            | /CF=  Couleur Fond');
 Writeln('/CGT= Crer G Table                   | /CT=  Couleur Trait');
 Writeln('/D   conversion en DRCS              | /G0=  npremier caract.,nombre');
 Writeln('/G1=  npremier caract.,nombre        | /GS  Jeu G1 standard et disjoint');
 Writeln('/GSD Jeu G1 standard disjoint        | /GC  utilise jeux G0 et G2');
 Writeln('/GCP utilise jeux G0 et G2 "proche"  | /GT=  ntable ou chaine G0 G2');
 Writeln('/GTP= ntable ou chaine G0 G2 "proche"| /M0=  Message en ligne 0 (/MT=2)');
 Writeln('/MT=  Moment ou Methode de Tlchargem| /OD  Optimise jeux DRCS');
 Writeln('/ODM Optimise DRCS en Mixant G0 G1 G2| /OI  Optimise avec les Inverses');
 Writeln('/OP  Optimise avec des car."proches" | /OPD Optimise Proche DRCS');
 Writeln('/OPM Optimise Proche Mixte G0 G1 G2  | /OPP Optimisation Proche Pousse');
 Writeln('/OPR Optimisati.Proche pousse Rapide| /OPV Optimise Proche Variable');
 Writeln('/OPX Optimise Proche au maXimun      | /OSP Optimise Semi-Graph.Proche');
 Writeln('/PE=  taux Proche Erreur              | /RD=  Rsolution caractres DRCS');
 Writeln('/TP  Taille en Proportion            | /TT=  Taille Texte');
 Writeln('/VD  Vide DRCS (/MT=0 ou MT=1,1+)    |');
 Writeln;
 Pause;
 Writeln('                        -----( JPEG/Photo /J+ /D- )-----');
 Writeln('/J   conversion en JPEG/Photo        | /JCP= texte libre  inclure');
 Writeln('/JEX= logiciel externe                | /JFF filtre le JPEG');
 Writeln('/JJ  idem /J, conversion tapes 2 & 3| /JM  positionnement JPEG/photo');
 Writeln('/JPA= paramtres du logiciel          | /JQ=  qualit conversion');
 Writeln('/JV=  idem /J, conversion tape 3');
 Writeln('ATTENTION: Par dfaut PCX2VDT utilise ALCHEMY.EXE pour ce mode de conversion.');
 Writeln('           ALCHEMY est un SHAREWARE (C) Handmade Software, Inc.');
 Writeln;
 Writeln('                        -----( Options Spciales )-----');
 Writeln('/CFG  enregistre les options          | /CZ   Ignore les options de fichiers');
 Writeln('/ENV  Envoyer un fichier sur minitel  | /LST  LiSTe des options utilises');
 Writeln('/PCX sauve ce que "voit" PCX2VDT     | /PZ  lecture de PCX bogu...');
 Writeln;
 Pause;
 EndHelp;
End;


begin
 SetCBreak(TRUE);
 Writeln('PCX2VDT  2.4  Copyright (c) 1991,93 T.Jaouen');
 if ParamCount>0 then
  begin

   Byte(DefaultCfg.CSI) := 255;   { signale non dfini }
   Byte(OptWithVide) := 255;  { signale non dfini }

   PCXName     := '';
   VDTName     := '';
   DefaultPath := '';
   DefaultExt  := '.VDT';

   TabG[0].First := 0;
   TabG[0].Nb    := GCharMax;
   TabG[1].First := 0;
   TabG[1].Nb    := GCharMax;

   M0Str         := 'Tlchargement DRCS en cours'+#27+#72+'...';
   JPEGExec      := Default_JPEGExec;
   JPEGExecParam := Default_JPEGExecParam;

   If ChargeParam then
    begin
     If SpeedReel=SpeedUndef Then
      If ConvMode=CM_JPEG Then SpeedReel := Speed4800
      Else SpeedReel := Speed1200;

     If PCXName='' Then Writeln('Nom du fichier PCX ou CFG absent !')
     Else
      Case WorkOptions Of
       CFG_SAVE : SaveOptions;
       CFG_NIL  :
        Begin
         If AjustCom Then
          Begin
           InstallC18;
           If ConvMode=CM_ENV Then EnvoiMinitel
           Else
            If VerifyFileDest And OpenHeader then
             Begin


              ReadInit;

              Case ConvMode Of
               CM_DRCS         : Prepare_DRCS;
               CM_PCX          : Begin
                                  TailleProp := FALSE;
                                  Prepare_DRCS;
                                 End;
               CM_JPEG         : Begin
                                  TailleProp := FALSE;
                                  Prepare_DRCS;
                                 End;
               CM_SemiGraph    : Prepare_Videotex;
              End;

              Write('Image ''',PCXName,''' ',xMax,'x',yMax,'x',LgPal,
                    ' => ',gLg,'x',gNb,' => ',dLg,'x',dNb);
              Case ConvMode Of
               CM_DRCS : Writeln(' (DRCS)');
               CM_PCX  : Writeln(' (PCX)');
               CM_JPEG : Writeln(' (JPEG/Photo)');
              Else Writeln(' (Semi-Graph.)');
              End;

              ReadStart;

              If ConvMode=CM_PCX Then SauvePCX
              Else
               If ConvMode=CM_JPEG Then ToJPEG
               Else
                Begin
                 DebutCom;

                 If Transforme Then
                  Begin

                   If ConvMode=CM_DRCS Then SauveDRCS
                   Else Sauve;

                   FRam.Done;
                  End;

                 FinCom;
                End;

             End;
           MyExitC18;
          End;
        End;
      Else ListOptions;
      End;
    End
   Else If NeedHelp Then CompleteHelp;
  End
 Else ShortHelp;
end.
